define(['dart_sdk', 'packages/analyzer/lib__analyzer'], function(dart_sdk, lib__analyzer) {
  'use strict';
  const core = dart_sdk.core;
  const dart = dart_sdk.dart;
  const dartx = dart_sdk.dartx;
  const dart__ast__ast = lib__analyzer.dart__ast__ast;
  const analyzer = lib__analyzer.analyzer;
  const _root = Object.create(null);
  const test_utils = Object.create(_root);
  test_utils.TestAnnotation = class TestAnnotation extends core.Object {
    get positional() {
      return this[positional$];
    }
    set positional(value) {
      super.positional = value;
    }
    get named() {
      return this[named$];
    }
    set named(value) {
      super.named = value;
    }
    get namedConstructorOnly() {
      return this[namedConstructorOnly$];
    }
    set namedConstructorOnly(value) {
      super.namedConstructorOnly = value;
    }
  };
  (test_utils.TestAnnotation.new = function(positional, opts) {
    let named = opts && 'named' in opts ? opts.named : null;
    this[positional$] = positional;
    this[named$] = named;
    this[namedConstructorOnly$] = null;
  }).prototype = test_utils.TestAnnotation.prototype;
  (test_utils.TestAnnotation.namedConstructor = function(opts) {
    let namedConstructorOnly = opts && 'namedConstructorOnly' in opts ? opts.namedConstructorOnly : null;
    this[namedConstructorOnly$] = namedConstructorOnly;
    this[positional$] = null;
    this[named$] = null;
  }).prototype = test_utils.TestAnnotation.prototype;
  dart.addTypeTests(test_utils.TestAnnotation);
  const positional$ = Symbol("TestAnnotation.positional");
  const named$ = Symbol("TestAnnotation.named");
  const namedConstructorOnly$ = Symbol("TestAnnotation.namedConstructorOnly");
  dart.setFieldSignature(test_utils.TestAnnotation, () => ({
    __proto__: dart.getFields(test_utils.TestAnnotation.__proto__),
    positional: dart.finalFieldType(dart.dynamic),
    named: dart.finalFieldType(dart.dynamic),
    namedConstructorOnly: dart.finalFieldType(dart.dynamic)
  }));
  test_utils.getConstructor = function(classDecl, opts) {
    let name = opts && 'name' in opts ? opts.name : null;
    for (let member of classDecl.members) {
      if (dart__ast__ast.ConstructorDeclaration.is(member) && (() => {
        let t = member.name;
        return t == null ? null : t.name;
      })() == name) {
        return member;
      }
    }
    return null;
  };
  test_utils.getFieldByName = function(classDecl, name) {
    for (let member of classDecl.members) {
      if (dart__ast__ast.FieldDeclaration.is(member) && member.fields.variables.first.name.name == name) {
        return member;
      }
    }
    return null;
  };
  test_utils.getMethodByName = function(classDecl, name) {
    for (let member of classDecl.members) {
      if (dart__ast__ast.MethodDeclaration.is(member) && member.name.name == name) {
        return member;
      }
    }
    return null;
  };
  test_utils.parseAndGetSingleMember = function(source) {
    let compilationUnit = analyzer.parseCompilationUnit(source);
    return compilationUnit.declarations.single;
  };
  dart.trackLibraries("test/test__shared_0", {
    "test_utils.dart": test_utils
  }, '{"version":3,"sourceRoot":"","sources":["test_utils.dart"],"names":[],"mappings":";;;;;;;;;;IAmBQ;;;;;;IACA;;;;;;IACA;;;;;;;4CACe,UAAe;QAAQ;IAAlB,iBAAU,GAAV,UAAU;IAAQ,YAAK,GAAL,KAAK;IAC3C,2BAAoB,GAAG;EAAI;;QACW;+BAAoB,GAApB,oBAAoB;IAC1D,iBAAU,GAAG;IACb,YAAK,GAAG;EAAI;;;;;;;;;;;uCAGkB,SAA0B;QACpD;AACV,aAAS,SAAU,UAAS,QAAQ,EAAE;AACpC,mDAAI,MAAM;gBAA8B,MAAM,KAAK;;cAAU,IAAI,EAAE;AACjE,cAAO,OAAM;;;AAGjB,UAAO;EACT;uCAEgC,SAA0B,EAAE,IAAW;AACrE,aAAS,SAAU,UAAS,QAAQ,EAAE;AACpC,6CAAI,MAAM,KACN,MAAM,OAAO,UAAU,MAAM,KAAK,KAAK,IAAI,IAAI,EAAE;AACnD,cAAO,OAAM;;;AAGjB,UAAO;EACT;wCAEkC,SAA0B,EAAE,IAAW;AACvE,aAAS,SAAU,UAAS,QAAQ,EAAE;AACpC,8CAAI,MAAM,KAAyB,MAAM,KAAK,KAAK,IAAI,IAAI,EAAE;AAC3D,cAAO,OAAM;;;AAGjB,UAAO;EACT;gDAE8C,MAAa;AACzD,QAAI,kBAAkB,6BAAoB,CAAC,MAAM;AACjD,UAAO,gBAAe,aAAa,OAAO;EAC5C","file":"test__shared_0.js"}');
  // Exports:
  return {
    test_utils: test_utils
  };
});

//# sourceMappingURL=test__shared_0.js.map
