define(['dart_sdk', 'packages/test/lib__test', 'test/test__shared_0', 'packages/analyzer/lib__analyzer', 'packages/transformer_utils/lib__transformer_utils', 'packages/matcher/lib__shared_0'], function(dart_sdk, lib__test, test__shared_0, lib__analyzer, lib__transformer_utils, lib__shared_0) {
  'use strict';
  const core = dart_sdk.core;
  const _interceptors = dart_sdk._interceptors;
  const async = dart_sdk.async;
  const dart = dart_sdk.dart;
  const dartx = dart_sdk.dartx;
  const src__frontend__expect = lib__test.src__frontend__expect;
  const src__frontend__throws_matchers = lib__test.src__frontend__throws_matchers;
  const test = lib__test.test;
  const src__frontend__throws_matcher = lib__test.src__frontend__throws_matcher;
  const test_utils = test__shared_0.test_utils;
  const dart__ast__ast = lib__analyzer.dart__ast__ast;
  const analyzer = lib__analyzer.analyzer;
  const src__analyzer_helpers = lib__transformer_utils.src__analyzer_helpers;
  const src__core_matchers = lib__shared_0.src__core_matchers;
  const src__string_matchers = lib__shared_0.src__string_matchers;
  const _root = Object.create(null);
  const unit__analyzer_helpers_test = Object.create(_root);
  const $split = dartx.split;
  const $length = dartx.length;
  const $trim = dartx.trim;
  const $_get = dartx._get;
  const $join = dartx.join;
  let VoidToNull = () => (VoidToNull = dart.constFn(dart.fnType(core.Null, [])))();
  let JSArrayOfString = () => (JSArrayOfString = dart.constFn(_interceptors.JSArray$(core.String)))();
  let FutureOfNull = () => (FutureOfNull = dart.constFn(async.Future$(core.Null)))();
  let VoidToFutureOfNull = () => (VoidToFutureOfNull = dart.constFn(dart.fnType(FutureOfNull(), [])))();
  let VoidTodynamic = () => (VoidTodynamic = dart.constFn(dart.fnType(dart.dynamic, [])))();
  let ExpressionToString = () => (ExpressionToString = dart.constFn(dart.fnType(core.String, [dart__ast__ast.Expression])))();
  let isInstanceOfOfExpression = () => (isInstanceOfOfExpression = dart.constFn(src__core_matchers.isInstanceOf$(dart__ast__ast.Expression)))();
  let isInstanceOfOfNamedExpression = () => (isInstanceOfOfNamedExpression = dart.constFn(src__core_matchers.isInstanceOf$(dart__ast__ast.NamedExpression)))();
  dart.defineLazy(unit__analyzer_helpers_test, {
    /*unit__analyzer_helpers_test.classDef*/get classDef() {
      return 'class TestClass {\n  TestClass();\n\n  var field = \'field\';\n  String typedField = \'typedField\';\n  static String staticField = \'typedField\';\n\n  get untypedGetter => null;\n  String get typedGetter => null;\n  static String get staticGetter => null;\n  Future get asyncGetter => null;\n\n  static void set staticSetter(v) { }\n  void set setter(v) { }\n  void set typedSetter(String v) { }\n\n  untypedMethod() { }\n  String typedMethod() { }\n  static String staticMethod() { }\n  Future asyncMethod() { }\n  String methodWithArgs(String a, {int b}) { }\n}\n';
    }
  });
  unit__analyzer_helpers_test.expectLines = function(actual, expected) {
    let expectedLines = expected[$split]('\n');
    let actualLines = actual[$split]('\n');
    for (let i = 0; i < dart.notNull(expectedLines[$length]); i++) {
      src__frontend__expect.expect(actualLines[$_get](i)[$trim](), expectedLines[$_get](i)[$trim]());
    }
  };
  let const$;
  let const$0;
  unit__analyzer_helpers_test.main = function() {
    test.group('copyClassMember()', dart.fn(() => {
      test.test('throws on unsupported class member', dart.fn(() => {
        let node = test_utils.parseAndGetSingleMember("class TestClass {\n  TestClass();\n\n  var field = 'field';\n  String typedField = 'typedField';\n  static String staticField = 'typedField';\n\n  get untypedGetter => null;\n  String get typedGetter => null;\n  static String get staticGetter => null;\n  Future get asyncGetter => null;\n\n  static void set staticSetter(v) { }\n  void set setter(v) { }\n  void set typedSetter(String v) { }\n\n  untypedMethod() { }\n  String typedMethod() { }\n  static String staticMethod() { }\n  Future asyncMethod() { }\n  String methodWithArgs(String a, {int b}) { }\n}\n");
        let ctor = test_utils.getConstructor(dart__ast__ast.ClassDeclaration._check(node));
        src__frontend__expect.expect(dart.fn(() => {
          src__analyzer_helpers.copyClassMember(ctor, 'body');
        }, VoidToNull()), src__frontend__throws_matchers.throwsUnsupportedError);
      }, VoidToNull()));
      test.group('FieldDeclaration', dart.fn(() => {
        test.test('copies an untyped field', dart.fn(() => {
          let node = test_utils.parseAndGetSingleMember("class TestClass {\n  TestClass();\n\n  var field = 'field';\n  String typedField = 'typedField';\n  static String staticField = 'typedField';\n\n  get untypedGetter => null;\n  String get typedGetter => null;\n  static String get staticGetter => null;\n  Future get asyncGetter => null;\n\n  static void set staticSetter(v) { }\n  void set setter(v) { }\n  void set typedSetter(String v) { }\n\n  untypedMethod() { }\n  String typedMethod() { }\n  static String staticMethod() { }\n  Future asyncMethod() { }\n  String methodWithArgs(String a, {int b}) { }\n}\n");
          let field = test_utils.getFieldByName(dart__ast__ast.ClassDeclaration._check(node), 'field');
          let expected = 'var field = "copy";';
          src__frontend__expect.expect(src__analyzer_helpers.copyClassMember(field, '"copy"'), src__core_matchers.equals(expected));
        }, VoidToNull()));
        test.test('copies a typed field', dart.fn(() => {
          let node = test_utils.parseAndGetSingleMember("class TestClass {\n  TestClass();\n\n  var field = 'field';\n  String typedField = 'typedField';\n  static String staticField = 'typedField';\n\n  get untypedGetter => null;\n  String get typedGetter => null;\n  static String get staticGetter => null;\n  Future get asyncGetter => null;\n\n  static void set staticSetter(v) { }\n  void set setter(v) { }\n  void set typedSetter(String v) { }\n\n  untypedMethod() { }\n  String typedMethod() { }\n  static String staticMethod() { }\n  Future asyncMethod() { }\n  String methodWithArgs(String a, {int b}) { }\n}\n");
          let field = test_utils.getFieldByName(dart__ast__ast.ClassDeclaration._check(node), 'typedField');
          let expected = 'String typedField = "copy";';
          src__frontend__expect.expect(src__analyzer_helpers.copyClassMember(field, '"copy"'), src__core_matchers.equals(expected));
        }, VoidToNull()));
        test.test('copies a static field', dart.fn(() => {
          let node = test_utils.parseAndGetSingleMember("class TestClass {\n  TestClass();\n\n  var field = 'field';\n  String typedField = 'typedField';\n  static String staticField = 'typedField';\n\n  get untypedGetter => null;\n  String get typedGetter => null;\n  static String get staticGetter => null;\n  Future get asyncGetter => null;\n\n  static void set staticSetter(v) { }\n  void set setter(v) { }\n  void set typedSetter(String v) { }\n\n  untypedMethod() { }\n  String typedMethod() { }\n  static String staticMethod() { }\n  Future asyncMethod() { }\n  String methodWithArgs(String a, {int b}) { }\n}\n");
          let field = test_utils.getFieldByName(dart__ast__ast.ClassDeclaration._check(node), 'staticField');
          let expected = 'static String staticField = "copy";';
          src__frontend__expect.expect(src__analyzer_helpers.copyClassMember(field, '"copy"'), src__core_matchers.equals(expected));
        }, VoidToNull()));
        test.test('copies a field witout an initializer', dart.fn(() => {
          let node = test_utils.parseAndGetSingleMember("class TestClass {\n  TestClass();\n\n  var field = 'field';\n  String typedField = 'typedField';\n  static String staticField = 'typedField';\n\n  get untypedGetter => null;\n  String get typedGetter => null;\n  static String get staticGetter => null;\n  Future get asyncGetter => null;\n\n  static void set staticSetter(v) { }\n  void set setter(v) { }\n  void set typedSetter(String v) { }\n\n  untypedMethod() { }\n  String typedMethod() { }\n  static String staticMethod() { }\n  Future asyncMethod() { }\n  String methodWithArgs(String a, {int b}) { }\n}\n");
          let field = test_utils.getFieldByName(dart__ast__ast.ClassDeclaration._check(node), 'typedField');
          let expected = 'String typedField;';
          src__frontend__expect.expect(src__analyzer_helpers.copyClassMember(field, ''), src__core_matchers.equals(expected));
        }, VoidToNull()));
      }, VoidToNull()));
      test.group('MethodDeclaration (Getter)', dart.fn(() => {
        test.test('copies untyped getter', dart.fn(() => {
          let node = test_utils.parseAndGetSingleMember("class TestClass {\n  TestClass();\n\n  var field = 'field';\n  String typedField = 'typedField';\n  static String staticField = 'typedField';\n\n  get untypedGetter => null;\n  String get typedGetter => null;\n  static String get staticGetter => null;\n  Future get asyncGetter => null;\n\n  static void set staticSetter(v) { }\n  void set setter(v) { }\n  void set typedSetter(String v) { }\n\n  untypedMethod() { }\n  String typedMethod() { }\n  static String staticMethod() { }\n  Future asyncMethod() { }\n  String methodWithArgs(String a, {int b}) { }\n}\n");
          let getter = test_utils.getMethodByName(dart__ast__ast.ClassDeclaration._check(node), 'untypedGetter');
          let expected = JSArrayOfString().of(['get untypedGetter {', 'return "copy";', '}'])[$join]('\n');
          unit__analyzer_helpers_test.expectLines(src__analyzer_helpers.copyClassMember(getter, 'return "copy";'), expected);
        }, VoidToNull()));
        test.test('copies typed getter', dart.fn(() => {
          let node = test_utils.parseAndGetSingleMember("class TestClass {\n  TestClass();\n\n  var field = 'field';\n  String typedField = 'typedField';\n  static String staticField = 'typedField';\n\n  get untypedGetter => null;\n  String get typedGetter => null;\n  static String get staticGetter => null;\n  Future get asyncGetter => null;\n\n  static void set staticSetter(v) { }\n  void set setter(v) { }\n  void set typedSetter(String v) { }\n\n  untypedMethod() { }\n  String typedMethod() { }\n  static String staticMethod() { }\n  Future asyncMethod() { }\n  String methodWithArgs(String a, {int b}) { }\n}\n");
          let getter = test_utils.getMethodByName(dart__ast__ast.ClassDeclaration._check(node), 'typedGetter');
          let expected = JSArrayOfString().of(['String get typedGetter {', 'return "copy";', '}'])[$join]('\n');
          unit__analyzer_helpers_test.expectLines(src__analyzer_helpers.copyClassMember(getter, 'return "copy";'), expected);
        }, VoidToNull()));
        test.test('copies static getter', dart.fn(() => {
          let node = test_utils.parseAndGetSingleMember("class TestClass {\n  TestClass();\n\n  var field = 'field';\n  String typedField = 'typedField';\n  static String staticField = 'typedField';\n\n  get untypedGetter => null;\n  String get typedGetter => null;\n  static String get staticGetter => null;\n  Future get asyncGetter => null;\n\n  static void set staticSetter(v) { }\n  void set setter(v) { }\n  void set typedSetter(String v) { }\n\n  untypedMethod() { }\n  String typedMethod() { }\n  static String staticMethod() { }\n  Future asyncMethod() { }\n  String methodWithArgs(String a, {int b}) { }\n}\n");
          let getter = test_utils.getMethodByName(dart__ast__ast.ClassDeclaration._check(node), 'staticGetter');
          let expected = JSArrayOfString().of(['static String get staticGetter {', 'return "copy";', '}'])[$join]('\n');
          unit__analyzer_helpers_test.expectLines(src__analyzer_helpers.copyClassMember(getter, 'return "copy";'), expected);
        }, VoidToNull()));
        test.test('copies async getter', dart.fn(() => {
          let node = test_utils.parseAndGetSingleMember("class TestClass {\n  TestClass();\n\n  var field = 'field';\n  String typedField = 'typedField';\n  static String staticField = 'typedField';\n\n  get untypedGetter => null;\n  String get typedGetter => null;\n  static String get staticGetter => null;\n  Future get asyncGetter => null;\n\n  static void set staticSetter(v) { }\n  void set setter(v) { }\n  void set typedSetter(String v) { }\n\n  untypedMethod() { }\n  String typedMethod() { }\n  static String staticMethod() { }\n  Future asyncMethod() { }\n  String methodWithArgs(String a, {int b}) { }\n}\n");
          let getter = test_utils.getMethodByName(dart__ast__ast.ClassDeclaration._check(node), 'asyncGetter');
          let expected = JSArrayOfString().of(['Future get asyncGetter async {', 'return "copy";', '}'])[$join]('\n');
          unit__analyzer_helpers_test.expectLines(src__analyzer_helpers.copyClassMember(getter, 'return "copy";'), expected);
        }, VoidToNull()));
      }, VoidToNull()));
      test.group('MethodDeclaration (Setter)', dart.fn(() => {
        test.test('copies setter', dart.fn(() => {
          let node = test_utils.parseAndGetSingleMember("class TestClass {\n  TestClass();\n\n  var field = 'field';\n  String typedField = 'typedField';\n  static String staticField = 'typedField';\n\n  get untypedGetter => null;\n  String get typedGetter => null;\n  static String get staticGetter => null;\n  Future get asyncGetter => null;\n\n  static void set staticSetter(v) { }\n  void set setter(v) { }\n  void set typedSetter(String v) { }\n\n  untypedMethod() { }\n  String typedMethod() { }\n  static String staticMethod() { }\n  Future asyncMethod() { }\n  String methodWithArgs(String a, {int b}) { }\n}\n");
          let setter = test_utils.getMethodByName(dart__ast__ast.ClassDeclaration._check(node), 'setter');
          let expected = JSArrayOfString().of(['void set setter(v) {', 'c = "copy";', '}'])[$join]('\n');
          unit__analyzer_helpers_test.expectLines(src__analyzer_helpers.copyClassMember(setter, 'c = "copy";'), expected);
        }, VoidToNull()));
        test.test('copies typed setter', dart.fn(() => {
          let node = test_utils.parseAndGetSingleMember("class TestClass {\n  TestClass();\n\n  var field = 'field';\n  String typedField = 'typedField';\n  static String staticField = 'typedField';\n\n  get untypedGetter => null;\n  String get typedGetter => null;\n  static String get staticGetter => null;\n  Future get asyncGetter => null;\n\n  static void set staticSetter(v) { }\n  void set setter(v) { }\n  void set typedSetter(String v) { }\n\n  untypedMethod() { }\n  String typedMethod() { }\n  static String staticMethod() { }\n  Future asyncMethod() { }\n  String methodWithArgs(String a, {int b}) { }\n}\n");
          let setter = test_utils.getMethodByName(dart__ast__ast.ClassDeclaration._check(node), 'typedSetter');
          let expected = JSArrayOfString().of(['void set typedSetter(String v) {', 'c = "copy";', '}'])[$join]('\n');
          unit__analyzer_helpers_test.expectLines(src__analyzer_helpers.copyClassMember(setter, 'c = "copy";'), expected);
        }, VoidToNull()));
        test.test('copies static setter', dart.fn(() => {
          let node = test_utils.parseAndGetSingleMember("class TestClass {\n  TestClass();\n\n  var field = 'field';\n  String typedField = 'typedField';\n  static String staticField = 'typedField';\n\n  get untypedGetter => null;\n  String get typedGetter => null;\n  static String get staticGetter => null;\n  Future get asyncGetter => null;\n\n  static void set staticSetter(v) { }\n  void set setter(v) { }\n  void set typedSetter(String v) { }\n\n  untypedMethod() { }\n  String typedMethod() { }\n  static String staticMethod() { }\n  Future asyncMethod() { }\n  String methodWithArgs(String a, {int b}) { }\n}\n");
          let setter = test_utils.getMethodByName(dart__ast__ast.ClassDeclaration._check(node), 'staticSetter');
          let expected = JSArrayOfString().of(['static void set staticSetter(v) {', 'c = "copy";', '}'])[$join]('\n');
          unit__analyzer_helpers_test.expectLines(src__analyzer_helpers.copyClassMember(setter, 'c = "copy";'), expected);
        }, VoidToNull()));
      }, VoidToNull()));
      test.group('MethodDeclaration', dart.fn(() => {
        test.test('copies untyped method', dart.fn(() => {
          let node = test_utils.parseAndGetSingleMember("class TestClass {\n  TestClass();\n\n  var field = 'field';\n  String typedField = 'typedField';\n  static String staticField = 'typedField';\n\n  get untypedGetter => null;\n  String get typedGetter => null;\n  static String get staticGetter => null;\n  Future get asyncGetter => null;\n\n  static void set staticSetter(v) { }\n  void set setter(v) { }\n  void set typedSetter(String v) { }\n\n  untypedMethod() { }\n  String typedMethod() { }\n  static String staticMethod() { }\n  Future asyncMethod() { }\n  String methodWithArgs(String a, {int b}) { }\n}\n");
          let method = test_utils.getMethodByName(dart__ast__ast.ClassDeclaration._check(node), 'untypedMethod');
          let expected = JSArrayOfString().of(['untypedMethod() {', 'c = "copy";', '}'])[$join]('\n');
          unit__analyzer_helpers_test.expectLines(src__analyzer_helpers.copyClassMember(method, 'c = "copy";'), expected);
        }, VoidToNull()));
        test.test('copies typed method', dart.fn(() => {
          let node = test_utils.parseAndGetSingleMember("class TestClass {\n  TestClass();\n\n  var field = 'field';\n  String typedField = 'typedField';\n  static String staticField = 'typedField';\n\n  get untypedGetter => null;\n  String get typedGetter => null;\n  static String get staticGetter => null;\n  Future get asyncGetter => null;\n\n  static void set staticSetter(v) { }\n  void set setter(v) { }\n  void set typedSetter(String v) { }\n\n  untypedMethod() { }\n  String typedMethod() { }\n  static String staticMethod() { }\n  Future asyncMethod() { }\n  String methodWithArgs(String a, {int b}) { }\n}\n");
          let method = test_utils.getMethodByName(dart__ast__ast.ClassDeclaration._check(node), 'typedMethod');
          let expected = JSArrayOfString().of(['String typedMethod() {', 'c = "copy";', '}'])[$join]('\n');
          unit__analyzer_helpers_test.expectLines(src__analyzer_helpers.copyClassMember(method, 'c = "copy";'), expected);
        }, VoidToNull()));
        test.test('copies static method', dart.fn(() => {
          let node = test_utils.parseAndGetSingleMember("class TestClass {\n  TestClass();\n\n  var field = 'field';\n  String typedField = 'typedField';\n  static String staticField = 'typedField';\n\n  get untypedGetter => null;\n  String get typedGetter => null;\n  static String get staticGetter => null;\n  Future get asyncGetter => null;\n\n  static void set staticSetter(v) { }\n  void set setter(v) { }\n  void set typedSetter(String v) { }\n\n  untypedMethod() { }\n  String typedMethod() { }\n  static String staticMethod() { }\n  Future asyncMethod() { }\n  String methodWithArgs(String a, {int b}) { }\n}\n");
          let method = test_utils.getMethodByName(dart__ast__ast.ClassDeclaration._check(node), 'staticMethod');
          let expected = JSArrayOfString().of(['static String staticMethod() {', 'c = "copy";', '}'])[$join]('\n');
          unit__analyzer_helpers_test.expectLines(src__analyzer_helpers.copyClassMember(method, 'c = "copy";'), expected);
        }, VoidToNull()));
        test.test('copies async method', dart.fn(() => async.async(core.Null, function*() {
          let node = test_utils.parseAndGetSingleMember("class TestClass {\n  TestClass();\n\n  var field = 'field';\n  String typedField = 'typedField';\n  static String staticField = 'typedField';\n\n  get untypedGetter => null;\n  String get typedGetter => null;\n  static String get staticGetter => null;\n  Future get asyncGetter => null;\n\n  static void set staticSetter(v) { }\n  void set setter(v) { }\n  void set typedSetter(String v) { }\n\n  untypedMethod() { }\n  String typedMethod() { }\n  static String staticMethod() { }\n  Future asyncMethod() { }\n  String methodWithArgs(String a, {int b}) { }\n}\n");
          let method = test_utils.getMethodByName(dart__ast__ast.ClassDeclaration._check(node), 'asyncMethod');
          let expected = JSArrayOfString().of(['Future asyncMethod() async {', 'c = "copy";', '}'])[$join]('\n');
          unit__analyzer_helpers_test.expectLines(src__analyzer_helpers.copyClassMember(method, 'c = "copy";'), expected);
        }), VoidToFutureOfNull()));
        test.test('copies method with args', dart.fn(() => async.async(core.Null, function*() {
          let node = test_utils.parseAndGetSingleMember("class TestClass {\n  TestClass();\n\n  var field = 'field';\n  String typedField = 'typedField';\n  static String staticField = 'typedField';\n\n  get untypedGetter => null;\n  String get typedGetter => null;\n  static String get staticGetter => null;\n  Future get asyncGetter => null;\n\n  static void set staticSetter(v) { }\n  void set setter(v) { }\n  void set typedSetter(String v) { }\n\n  untypedMethod() { }\n  String typedMethod() { }\n  static String staticMethod() { }\n  Future asyncMethod() { }\n  String methodWithArgs(String a, {int b}) { }\n}\n");
          let method = test_utils.getMethodByName(dart__ast__ast.ClassDeclaration._check(node), 'methodWithArgs');
          let expected = JSArrayOfString().of(['String methodWithArgs(String a, {int b}) {', 'c = "copy";', '}'])[$join]('\n');
          unit__analyzer_helpers_test.expectLines(src__analyzer_helpers.copyClassMember(method, 'c = "copy";'), expected);
        }), VoidToFutureOfNull()));
      }, VoidToNull()));
    }, VoidToNull()));
    test.group('getDeclarationsAnnotatedBy()', dart.fn(() => {
      test.test('no matching declarations', dart.fn(() => {
        let unit = analyzer.parseCompilationUnit(JSArrayOfString().of(['var a;', '@OtherAnnotation()', 'var b;', 'var c;'])[$join]('\n'));
        let matches = src__analyzer_helpers.getDeclarationsAnnotatedBy(unit, dart.wrapType(test_utils.TestAnnotation));
        src__frontend__expect.expect(matches, src__core_matchers.isEmpty);
      }, VoidToNull()));
      test.test('one matching declaration', dart.fn(() => {
        let unit = analyzer.parseCompilationUnit(JSArrayOfString().of(['@TestAnnotation("test")', 'var a;', '@OtherAnnotation()', 'var b;', 'var c;'])[$join]('\n'));
        let matches = src__analyzer_helpers.getDeclarationsAnnotatedBy(unit, dart.wrapType(test_utils.TestAnnotation));
        src__frontend__expect.expect(matches[$length], 1);
      }, VoidToNull()));
      test.test('multiple matching declarations', dart.fn(() => {
        let unit = analyzer.parseCompilationUnit(JSArrayOfString().of(['@TestAnnotation("test")', 'var a;', '@OtherAnnotation()', 'var b;', '@TestAnnotation("test")', 'var c;'])[$join]('\n'));
        let matches = src__analyzer_helpers.getDeclarationsAnnotatedBy(unit, dart.wrapType(test_utils.TestAnnotation));
        src__frontend__expect.expect(matches[$length], 2);
      }, VoidToNull()));
    }, VoidToNull()));
    test.group('instantiateAnnotation()', dart.fn(() => {
      test.group('instantiates an annotation with a parameter value specified as', dart.fn(() => {
        test.test('a string literal', dart.fn(() => {
          let node = test_utils.parseAndGetSingleMember('@TestAnnotation("hello")\nvar a;');
          let instance = test_utils.TestAnnotation._check(src__analyzer_helpers.instantiateAnnotation(node, dart.wrapType(test_utils.TestAnnotation)));
          src__frontend__expect.expect(instance.positional, "hello");
        }, VoidToNull()));
        test.test('a concatenated string literal', dart.fn(() => {
          let node = test_utils.parseAndGetSingleMember('@TestAnnotation("he" "y")\nvar a;');
          let instance = test_utils.TestAnnotation._check(src__analyzer_helpers.instantiateAnnotation(node, dart.wrapType(test_utils.TestAnnotation)));
          src__frontend__expect.expect(instance.positional, "hey");
        }, VoidToNull()));
        test.test('a boolean literal', dart.fn(() => {
          let node = test_utils.parseAndGetSingleMember('@TestAnnotation(true)\nvar a;');
          let instance = test_utils.TestAnnotation._check(src__analyzer_helpers.instantiateAnnotation(node, dart.wrapType(test_utils.TestAnnotation)));
          src__frontend__expect.expect(instance.positional, true);
        }, VoidToNull()));
        test.test('an integer literal', dart.fn(() => {
          let node = test_utils.parseAndGetSingleMember('@TestAnnotation(1)\nvar a;');
          let instance = test_utils.TestAnnotation._check(src__analyzer_helpers.instantiateAnnotation(node, dart.wrapType(test_utils.TestAnnotation)));
          src__frontend__expect.expect(instance.positional, 1);
        }, VoidToNull()));
        test.test('a null literal', dart.fn(() => {
          let node = test_utils.parseAndGetSingleMember('@TestAnnotation(null)\nvar a;');
          let instance = test_utils.TestAnnotation._check(src__analyzer_helpers.instantiateAnnotation(node, dart.wrapType(test_utils.TestAnnotation)));
          src__frontend__expect.expect(instance.positional, null);
        }, VoidToNull()));
      }, VoidToNull()));
      test.group('throws when an annotation parameter value is unsupported:', dart.fn(() => {
        test.test('a constant expression', dart.fn(() => {
          let node = test_utils.parseAndGetSingleMember('@TestAnnotation(const [])\nvar a;');
          src__frontend__expect.expect(dart.fn(() => src__analyzer_helpers.instantiateAnnotation(node, dart.wrapType(test_utils.TestAnnotation)), VoidTodynamic()), src__frontend__throws_matchers.throwsUnsupportedError);
        }, VoidToNull()));
        test.test('an interpolated String', dart.fn(() => {
          let node = test_utils.parseAndGetSingleMember('@TestAnnotation("$v")\nvar a;');
          src__frontend__expect.expect(dart.fn(() => src__analyzer_helpers.instantiateAnnotation(node, dart.wrapType(test_utils.TestAnnotation)), VoidTodynamic()), src__frontend__throws_matchers.throwsUnsupportedError);
        }, VoidToNull()));
        test.test('an identifier', dart.fn(() => {
          let node = test_utils.parseAndGetSingleMember('@TestAnnotation(identifier)\nvar a;');
          src__frontend__expect.expect(dart.fn(() => src__analyzer_helpers.instantiateAnnotation(node, dart.wrapType(test_utils.TestAnnotation)), VoidTodynamic()), src__frontend__throws_matchers.throwsUnsupportedError);
        }, VoidToNull()));
        test.group('(except when `onUnsupportedArgument` is specified)', dart.fn(() => {
          test.test('positional parameter', dart.fn(() => {
            let unsupportedArgument = null;
            let instance = test_utils.TestAnnotation._check(src__analyzer_helpers.instantiateAnnotation(test_utils.parseAndGetSingleMember('@TestAnnotation(const [])\nvar a;'), dart.wrapType(test_utils.TestAnnotation), {onUnsupportedArgument: dart.fn(expression => {
                unsupportedArgument = expression;
                return 'value to be passed to constructor instead';
              }, ExpressionToString())}));
            src__frontend__expect.expect(unsupportedArgument, const$ || (const$ = dart.const(new (isInstanceOfOfExpression()).new())));
            src__frontend__expect.expect(instance.positional, src__core_matchers.equals('value to be passed to constructor instead'), {reason: 'should have passed the return value of `onUnsupportedArgument` to the constructor'});
          }, VoidToNull()));
          test.test('named parameter', dart.fn(() => {
            let unsupportedArgument = null;
            let instance = test_utils.TestAnnotation._check(src__analyzer_helpers.instantiateAnnotation(test_utils.parseAndGetSingleMember('@TestAnnotation.namedConstructor(namedConstructorOnly: const [])\nvar a;'), dart.wrapType(test_utils.TestAnnotation), {onUnsupportedArgument: dart.fn(expression => {
                unsupportedArgument = expression;
                return 'value to be passed to constructor instead';
              }, ExpressionToString())}));
            src__frontend__expect.expect(unsupportedArgument, const$0 || (const$0 = dart.const(new (isInstanceOfOfNamedExpression()).new())));
            src__frontend__expect.expect(dart__ast__ast.NamedExpression.as(unsupportedArgument).name.label.name, src__core_matchers.equals('namedConstructorOnly'));
            src__frontend__expect.expect(instance.namedConstructorOnly, src__core_matchers.equals('value to be passed to constructor instead'), {reason: 'should have passed the return value of `onUnsupportedArgument` to the constructor'});
          }, VoidToNull()));
        }, VoidToNull()));
      }, VoidToNull()));
      test.test('annotation with both named and positional parameters', dart.fn(() => {
        let node = test_utils.parseAndGetSingleMember('@TestAnnotation(1, named: 2)\nvar a;');
        let instance = test_utils.TestAnnotation._check(src__analyzer_helpers.instantiateAnnotation(node, dart.wrapType(test_utils.TestAnnotation)));
        src__frontend__expect.expect(instance.positional, 1);
        src__frontend__expect.expect(instance.named, 2);
      }, VoidToNull()));
      test.test('instantiates an annotation using a named constructor', dart.fn(() => {
        let node = test_utils.parseAndGetSingleMember('@TestAnnotation.namedConstructor(namedConstructorOnly: true)\nvar a;');
        let instance = test_utils.TestAnnotation._check(src__analyzer_helpers.instantiateAnnotation(node, dart.wrapType(test_utils.TestAnnotation)));
        src__frontend__expect.expect(instance.namedConstructorOnly, true);
      }, VoidToNull()));
      test.test('throws if the annotation cannot be constructed', dart.fn(() => {
        let node = test_utils.parseAndGetSingleMember('@TestAnnotation(1, 2, 3, 4, "way more parameters than were declared")\nvar a;');
        src__frontend__expect.expect(dart.fn(() => {
          src__analyzer_helpers.instantiateAnnotation(node, dart.wrapType(test_utils.TestAnnotation));
        }, VoidToNull()), src__frontend__throws_matcher.throwsA(src__string_matchers.startsWith('Unable to instantiate annotation')));
      }, VoidToNull()));
      test.test('throws if the annotation is not used as a constructor', dart.fn(() => {
        let node = test_utils.parseAndGetSingleMember('@TestAnnotation\nvar a;');
        src__frontend__expect.expect(dart.fn(() => {
          src__analyzer_helpers.instantiateAnnotation(node, dart.wrapType(test_utils.TestAnnotation));
        }, VoidToNull()), src__frontend__throws_matcher.throwsA(src__string_matchers.startsWith('Annotation not invocation of constructor')));
      }, VoidToNull()));
      test.test('returns null when the member is not annotated', dart.fn(() => {
        let node = test_utils.parseAndGetSingleMember('var a;');
        src__frontend__expect.expect(src__analyzer_helpers.instantiateAnnotation(node, dart.wrapType(test_utils.TestAnnotation)), src__core_matchers.isNull);
      }, VoidToNull()));
      test.test('returns null when the member has only non-matching annotations', dart.fn(() => {
        let node = test_utils.parseAndGetSingleMember('@NonexistantAnnotation\nvar a;');
        src__frontend__expect.expect(src__analyzer_helpers.instantiateAnnotation(node, dart.wrapType(test_utils.TestAnnotation)), src__core_matchers.isNull);
      }, VoidToNull()));
      test.test('returns null when the member has no annotations', dart.fn(() => {
        let node = test_utils.parseAndGetSingleMember('var a;');
        src__frontend__expect.expect(src__analyzer_helpers.instantiateAnnotation(node, dart.wrapType(test_utils.TestAnnotation)), src__core_matchers.isNull);
      }, VoidToNull()));
    }, VoidToNull()));
  };
  dart.trackLibraries("test/test__unit__analyzer_helpers_test", {
    "unit/analyzer_helpers_test.dart": unit__analyzer_helpers_test
  }, '{"version":3,"sourceRoot":"","sources":["unit/analyzer_helpers_test.dart"],"names":[],"mappings":";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;MAwBa,oCAAQ;YAAG;;;qDAyBP,MAAa,EAAE,QAAe;AAC7C,QAAI,gBAAgB,QAAQ,QAAM,CAAC;AACnC,QAAI,cAAc,MAAM,QAAM,CAAC;AAC/B,aAAS,IAAI,GAAG,AAAE,CAAD,gBAAG,aAAa,SAAO,GAAE,CAAC,IAAI;AAC7C,kCAAM,CAAC,WAAW,QAAC,CAAC,QAAM,IAAI,aAAa,QAAC,CAAC,QAAM;;EAEvD;;;;AAGE,cAAK,CAAC,qBAAqB;AACzB,eAAI,CAAC,sCAAsC;AACzC,YAAI,OAAO,kCAAuB,CAAC,mjBAAQ;AAC3C,YAAI,OAAO,yBAAc,wCAAC,IAAI;AAC9B,oCAAM,CAAC;AACL,+CAAe,CAAC,IAAI,EAAE;0BACrB,qDAAsB;;AAG3B,gBAAK,CAAC,oBAAoB;AACxB,iBAAI,CAAC,2BAA2B;AAC9B,cAAI,OAAO,kCAAuB,CAAC,mjBAAQ;AAC3C,cAAI,QAAQ,yBAAc,wCAAC,IAAI,GAAE;AACjC,cAAI,WAAW;AACf,sCAAM,CAAC,qCAAe,CAAC,KAAK,EAAE,WAAW,yBAAM,CAAC,QAAQ;;AAG1D,iBAAI,CAAC,wBAAwB;AAC3B,cAAI,OAAO,kCAAuB,CAAC,mjBAAQ;AAC3C,cAAI,QAAQ,yBAAc,wCAAC,IAAI,GAAE;AACjC,cAAI,WAAW;AACf,sCAAM,CAAC,qCAAe,CAAC,KAAK,EAAE,WAAW,yBAAM,CAAC,QAAQ;;AAG1D,iBAAI,CAAC,yBAAyB;AAC5B,cAAI,OAAO,kCAAuB,CAAC,mjBAAQ;AAC3C,cAAI,QAAQ,yBAAc,wCAAC,IAAI,GAAE;AACjC,cAAI,WAAW;AACf,sCAAM,CAAC,qCAAe,CAAC,KAAK,EAAE,WAAW,yBAAM,CAAC,QAAQ;;AAG1D,iBAAI,CAAC,wCAAwC;AAC3C,cAAI,OAAO,kCAAuB,CAAC,mjBAAQ;AAC3C,cAAI,QAAQ,yBAAc,wCAAC,IAAI,GAAE;AACjC,cAAI,WAAW;AACf,sCAAM,CAAC,qCAAe,CAAC,KAAK,EAAE,KAAK,yBAAM,CAAC,QAAQ;;;AAItD,gBAAK,CAAC,8BAA8B;AAClC,iBAAI,CAAC,yBAAyB;AAC5B,cAAI,OAAO,kCAAuB,CAAC,mjBAAQ;AAC3C,cAAI,SAAS,0BAAe,wCAAC,IAAI,GAAE;AACnC,cAAI,WACA,sBAAC,uBAAuB,kBAAkB,YAAS,CAAC;AACxD,iDAAW,CAAC,qCAAe,CAAC,MAAM,EAAE,mBAAmB,QAAQ;;AAGjE,iBAAI,CAAC,uBAAuB;AAC1B,cAAI,OAAO,kCAAuB,CAAC,mjBAAQ;AAC3C,cAAI,SAAS,0BAAe,wCAAC,IAAI,GAAE;AACnC,cAAI,WACA,sBAAC,4BAA4B,kBAAkB,YAAS,CAAC;AAC7D,iDAAW,CAAC,qCAAe,CAAC,MAAM,EAAE,mBAAmB,QAAQ;;AAGjE,iBAAI,CAAC,wBAAwB;AAC3B,cAAI,OAAO,kCAAuB,CAAC,mjBAAQ;AAC3C,cAAI,SAAS,0BAAe,wCAAC,IAAI,GAAE;AACnC,cAAI,WAAW,sBACb,oCACA,kBACA,YACI,CAAC;AACP,iDAAW,CAAC,qCAAe,CAAC,MAAM,EAAE,mBAAmB,QAAQ;;AAGjE,iBAAI,CAAC,uBAAuB;AAC1B,cAAI,OAAO,kCAAuB,CAAC,mjBAAQ;AAC3C,cAAI,SAAS,0BAAe,wCAAC,IAAI,GAAE;AACnC,cAAI,WAAW,sBAAC,kCAAkC,kBAAkB,YAC3D,CAAC;AACV,iDAAW,CAAC,qCAAe,CAAC,MAAM,EAAE,mBAAmB,QAAQ;;;AAInE,gBAAK,CAAC,8BAA8B;AAClC,iBAAI,CAAC,iBAAiB;AACpB,cAAI,OAAO,kCAAuB,CAAC,mjBAAQ;AAC3C,cAAI,SAAS,0BAAe,wCAAC,IAAI,GAAE;AACnC,cAAI,WAAW,sBAAC,wBAAwB,eAAe,YAAS,CAAC;AACjE,iDAAW,CAAC,qCAAe,CAAC,MAAM,EAAE,gBAAgB,QAAQ;;AAG9D,iBAAI,CAAC,uBAAuB;AAC1B,cAAI,OAAO,kCAAuB,CAAC,mjBAAQ;AAC3C,cAAI,SAAS,0BAAe,wCAAC,IAAI,GAAE;AACnC,cAAI,WACA,sBAAC,oCAAoC,eAAe,YAAS,CAAC;AAClE,iDAAW,CAAC,qCAAe,CAAC,MAAM,EAAE,gBAAgB,QAAQ;;AAG9D,iBAAI,CAAC,wBAAwB;AAC3B,cAAI,OAAO,kCAAuB,CAAC,mjBAAQ;AAC3C,cAAI,SAAS,0BAAe,wCAAC,IAAI,GAAE;AACnC,cAAI,WAAW,sBAAC,qCAAqC,eAAe,YAC3D,CAAC;AACV,iDAAW,CAAC,qCAAe,CAAC,MAAM,EAAE,gBAAgB,QAAQ;;;AAIhE,gBAAK,CAAC,qBAAqB;AACzB,iBAAI,CAAC,yBAAyB;AAC5B,cAAI,OAAO,kCAAuB,CAAC,mjBAAQ;AAC3C,cAAI,SAAS,0BAAe,wCAAC,IAAI,GAAE;AACnC,cAAI,WAAW,sBAAC,qBAAqB,eAAe,YAAS,CAAC;AAC9D,iDAAW,CAAC,qCAAe,CAAC,MAAM,EAAE,gBAAgB,QAAQ;;AAG9D,iBAAI,CAAC,uBAAuB;AAC1B,cAAI,OAAO,kCAAuB,CAAC,mjBAAQ;AAC3C,cAAI,SAAS,0BAAe,wCAAC,IAAI,GAAE;AACnC,cAAI,WACA,sBAAC,0BAA0B,eAAe,YAAS,CAAC;AACxD,iDAAW,CAAC,qCAAe,CAAC,MAAM,EAAE,gBAAgB,QAAQ;;AAG9D,iBAAI,CAAC,wBAAwB;AAC3B,cAAI,OAAO,kCAAuB,CAAC,mjBAAQ;AAC3C,cAAI,SAAS,0BAAe,wCAAC,IAAI,GAAE;AACnC,cAAI,WACA,sBAAC,kCAAkC,eAAe,YAAS,CAAC;AAChE,iDAAW,CAAC,qCAAe,CAAC,MAAM,EAAE,gBAAgB,QAAQ;;AAG9D,iBAAI,CAAC,uBAAuB;AAC1B,cAAI,OAAO,kCAAuB,CAAC,mjBAAQ;AAC3C,cAAI,SAAS,0BAAe,wCAAC,IAAI,GAAE;AACnC,cAAI,WACA,sBAAC,gCAAgC,eAAe,YAAS,CAAC;AAC9D,iDAAW,CAAC,qCAAe,CAAC,MAAM,EAAE,gBAAgB,QAAQ;QAC9D;AAEA,iBAAI,CAAC,2BAA2B;AAC9B,cAAI,OAAO,kCAAuB,CAAC,mjBAAQ;AAC3C,cAAI,SAAS,0BAAe,wCAAC,IAAI,GAAE;AACnC,cAAI,WAAW,sBACb,8CACA,eACA,YACI,CAAC;AACP,iDAAW,CAAC,qCAAe,CAAC,MAAM,EAAE,gBAAgB,QAAQ;QAC9D;;;AAIJ,cAAK,CAAC,gCAAgC;AACpC,eAAI,CAAC,4BAA4B;AAC/B,YAAI,OAAO,6BAAoB,CAC3B,sBAAC,UAAU,sBAAsB,UAAU,iBAAc,CAAC;AAC9D,YAAI,UAAU,gDAA0B,CAAC,IAAI,EAAE,wCAAc;AAC7D,oCAAM,CAAC,OAAO,EAAE,0BAAO;;AAGzB,eAAI,CAAC,4BAA4B;AAC/B,YAAI,OAAO,6BAAoB,CAAC,sBAC9B,2BACA,UACA,sBACA,UACA,iBACI,CAAC;AACP,YAAI,UAAU,gDAA0B,CAAC,IAAI,EAAE,wCAAc;AAC7D,oCAAM,CAAC,OAAO,SAAO,EAAE;;AAGzB,eAAI,CAAC,kCAAkC;AACrC,YAAI,OAAO,6BAAoB,CAAC,sBAC9B,2BACA,UACA,sBACA,UACA,2BACA,iBACI,CAAC;AACP,YAAI,UAAU,gDAA0B,CAAC,IAAI,EAAE,wCAAc;AAC7D,oCAAM,CAAC,OAAO,SAAO,EAAE;;;AAI3B,cAAK,CAAC,2BAA2B;AAC/B,gBAAK,CAAC,kEAAkE;AACtE,iBAAI,CAAC,oBAAoB;AACvB,cAAI,OAAO,kCAAuB,CAAC;AACnC,cAAe,4CAAW,2CAAqB,CAAC,IAAI,EAAE,wCAAc;AACpE,sCAAM,CAAC,QAAQ,WAAW,EAAE;;AAG9B,iBAAI,CAAC,iCAAiC;AACpC,cAAI,OAAO,kCAAuB,CAAC;AACnC,cAAe,4CAAW,2CAAqB,CAAC,IAAI,EAAE,wCAAc;AACpE,sCAAM,CAAC,QAAQ,WAAW,EAAE;;AAG9B,iBAAI,CAAC,qBAAqB;AACxB,cAAI,OAAO,kCAAuB,CAAC;AACnC,cAAe,4CAAW,2CAAqB,CAAC,IAAI,EAAE,wCAAc;AACpE,sCAAM,CAAC,QAAQ,WAAW,EAAE;;AAG9B,iBAAI,CAAC,sBAAsB;AACzB,cAAI,OAAO,kCAAuB,CAAC;AACnC,cAAe,4CAAW,2CAAqB,CAAC,IAAI,EAAE,wCAAc;AACpE,sCAAM,CAAC,QAAQ,WAAW,EAAE;;AAG9B,iBAAI,CAAC,kBAAkB;AACrB,cAAI,OAAO,kCAAuB,CAAC;AACnC,cAAe,4CAAW,2CAAqB,CAAC,IAAI,EAAE,wCAAc;AACpE,sCAAM,CAAC,QAAQ,WAAW,EAAE;;;AAIhC,gBAAK,CAAC,6DAA6D;AACjE,iBAAI,CAAC,yBAAyB;AAC5B,cAAI,OAAO,kCAAuB,CAAC;AACnC,sCAAM,CAAC,cAAM,2CAAqB,CAAC,IAAI,EAAE,wCAAc,qBACnD,qDAAsB;;AAG5B,iBAAI,CAAC,0BAA0B;AAC7B,cAAI,OAAO,kCAAuB,CAAC;AACnC,sCAAM,CAAC,cAAM,2CAAqB,CAAC,IAAI,EAAE,wCAAc,qBACnD,qDAAsB;;AAG5B,iBAAI,CAAC,iBAAiB;AACpB,cAAI,OACA,kCAAuB,CAAC;AAC5B,sCAAM,CAAC,cAAM,2CAAqB,CAAC,IAAI,EAAE,wCAAc,qBACnD,qDAAsB;;AAG5B,kBAAK,CAAC,sDAAsD;AAC1D,mBAAI,CAAC,wBAAwB;AAC3B,gBAAW;AAEX,gBAAe,4CAAW,2CAAqB,CAC3C,kCAAuB,CAAC,sCACxB,wCAAc,0BAAyB,QAAC,UAAqB;AAC/D,mCAAmB,GAAG,UAAU;AAChC,sBAAO;;AAGT,wCAAM,CAAC,mBAAmB,EAAE,mCAAM,gCAAwB;AAC1D,wCAAM,CAAC,QAAQ,WAAW,EACtB,yBAAM,CAAC,uDAEH;;AAGV,mBAAI,CAAC,mBAAmB;AACtB,gBAAW;AAEX,gBAAe,4CAAW,2CAAqB,CAC3C,kCAAuB,CACnB,6EACJ,wCAAc,0BAAyB,QAAC,UAAqB;AAC/D,mCAAmB,GAAG,UAAU;AAChC,sBAAO;;AAGT,wCAAM,CAAC,mBAAmB,EAAE,qCAAM,qCAA6B;AAC/D,wCAAM,mCAAE,mBAAmB,MAAyB,MAAM,KAAK,EAC3D,yBAAM,CAAC;AACX,wCAAM,CAAC,QAAQ,qBAAqB,EAChC,yBAAM,CAAC,uDAEH;;;;AAKd,eAAI,CAAC,wDAAwD;AAC3D,YAAI,OACA,kCAAuB,CAAC;AAC5B,YAAe,4CAAW,2CAAqB,CAAC,IAAI,EAAE,wCAAc;AACpE,oCAAM,CAAC,QAAQ,WAAW,EAAE;AAC5B,oCAAM,CAAC,QAAQ,MAAM,EAAE;;AAGzB,eAAI,CAAC,wDAAwD;AAC3D,YAAI,OAAO,kCAAuB,CAC9B;AACJ,YAAe,4CAAW,2CAAqB,CAAC,IAAI,EAAE,wCAAc;AACpE,oCAAM,CAAC,QAAQ,qBAAqB,EAAE;;AAGxC,eAAI,CAAC,kDAAkD;AACrD,YAAI,OAAO,kCAAuB,CAC9B;AACJ,oCAAM,CAAC;AACL,qDAAqB,CAAC,IAAI,EAAE,wCAAc;0BACzC,qCAAO,CAAC,+BAAU,CAAC;;AAGxB,eAAI,CAAC,yDAAyD;AAC5D,YAAI,OAAO,kCAAuB,CAAC;AACnC,oCAAM,CAAC;AACL,qDAAqB,CAAC,IAAI,EAAE,wCAAc;0BACzC,qCAAO,CAAC,+BAAU,CAAC;;AAGxB,eAAI,CAAC,iDAAiD;AACpD,YAAI,OAAO,kCAAuB,CAAC;AACnC,oCAAM,CAAC,2CAAqB,CAAC,IAAI,EAAE,wCAAc,GAAG,yBAAM;;AAG5D,eAAI,CAAC,kEAAkE;AACrE,YAAI,OAAO,kCAAuB,CAAC;AACnC,oCAAM,CAAC,2CAAqB,CAAC,IAAI,EAAE,wCAAc,GAAG,yBAAM;;AAG5D,eAAI,CAAC,mDAAmD;AACtD,YAAI,OAAO,kCAAuB,CAAC;AACnC,oCAAM,CAAC,2CAAqB,CAAC,IAAI,EAAE,wCAAc,GAAG,yBAAM;;;EAGhE","file":"test__unit__analyzer_helpers_test.js"}');
  // Exports:
  return {
    unit__analyzer_helpers_test: unit__analyzer_helpers_test
  };
});

//# sourceMappingURL=test__unit__analyzer_helpers_test.js.map
