define(['dart_sdk', 'packages/barback/lib__barback', 'packages/transformer_utils/lib__transformer_utils', 'packages/test/lib__test', 'packages/source_span/lib__source_span', 'packages/analyzer/lib__analyzer'], function(dart_sdk, lib__barback, lib__transformer_utils, lib__test, lib__source_span, lib__analyzer) {
  'use strict';
  const core = dart_sdk.core;
  const _interceptors = dart_sdk._interceptors;
  const dart = dart_sdk.dart;
  const dartx = dart_sdk.dartx;
  const src__asset__asset_id = lib__barback.src__asset__asset_id;
  const src__barback_utils = lib__transformer_utils.src__barback_utils;
  const src__frontend__expect = lib__test.src__frontend__expect;
  const test = lib__test.test;
  const src__file = lib__source_span.src__file;
  const analyzer = lib__analyzer.analyzer;
  const dart__ast__ast = lib__analyzer.dart__ast__ast;
  const _root = Object.create(null);
  const unit__barback_utils_test = Object.create(_root);
  const $last = dartx.last;
  const $join = dartx.join;
  const $first = dartx.first;
  let VoidToNull = () => (VoidToNull = dart.constFn(dart.fnType(core.Null, [])))();
  let JSArrayOfString = () => (JSArrayOfString = dart.constFn(_interceptors.JSArray$(core.String)))();
  dart.defineLazy(unit__barback_utils_test, {
    /*unit__barback_utils_test.sourceFileText*/get sourceFileText() {
      return 'var plainVar = "plain";\n\n/// Comment\n@Annotation()\nvar varWithCommentAndMeta = "annotated";\n';
    }
  });
  unit__barback_utils_test.main = function() {
    test.group('assetIdToPackageUri()', dart.fn(() => {
      test.test('returns original path for non-lib file', dart.fn(() => {
        let assetId = new src__asset__asset_id.AssetId.new('transformer_utils', 'test/test_utils.dart');
        src__frontend__expect.expect(src__barback_utils.assetIdToPackageUri(assetId), core.Uri.parse('test/test_utils.dart'));
      }, VoidToNull()));
      test.test('returns path with "package" scheme for lib file', dart.fn(() => {
        let assetId = new src__asset__asset_id.AssetId.new('transformer_utils', 'lib/transformer_utils.dart');
        src__frontend__expect.expect(src__barback_utils.assetIdToPackageUri(assetId), core.Uri.parse('package:transformer_utils/transformer_utils.dart'));
      }, VoidToNull()));
    }, VoidToNull()));
    test.group('getSpanForNode()', dart.fn(() => {
      test.test('should get node but skip comment and meta by default', dart.fn(() => {
        let sourceFile = new src__file.SourceFile.fromString("var plainVar = \"plain\";\n\n/// Comment\n@Annotation()\nvar varWithCommentAndMeta = \"annotated\";\n");
        let unit = analyzer.parseCompilationUnit("var plainVar = \"plain\";\n\n/// Comment\n@Annotation()\nvar varWithCommentAndMeta = \"annotated\";\n");
        let annotatedNode = dart__ast__ast.AstNode.as(unit.childEntities[$last]);
        let span = src__barback_utils.getSpanForNode(sourceFile, annotatedNode);
        src__frontend__expect.expect(span.text, 'var varWithCommentAndMeta = "annotated";');
      }, VoidToNull()));
      test.test('should not skip comment and meta if skip is false', dart.fn(() => {
        let sourceFile = new src__file.SourceFile.fromString("var plainVar = \"plain\";\n\n/// Comment\n@Annotation()\nvar varWithCommentAndMeta = \"annotated\";\n");
        let unit = analyzer.parseCompilationUnit("var plainVar = \"plain\";\n\n/// Comment\n@Annotation()\nvar varWithCommentAndMeta = \"annotated\";\n");
        let annotatedNode = dart__ast__ast.AstNode.as(unit.childEntities[$last]);
        let span = src__barback_utils.getSpanForNode(sourceFile, annotatedNode, {skipCommentAndMetadata: false});
        src__frontend__expect.expect(span.text, JSArrayOfString().of(['/// Comment', '@Annotation()', 'var varWithCommentAndMeta = "annotated";'])[$join]('\n'));
      }, VoidToNull()));
      test.test('should return the whole span if the node is not annotated', dart.fn(() => {
        let sourceFile = new src__file.SourceFile.fromString("var plainVar = \"plain\";\n\n/// Comment\n@Annotation()\nvar varWithCommentAndMeta = \"annotated\";\n");
        let unit = analyzer.parseCompilationUnit("var plainVar = \"plain\";\n\n/// Comment\n@Annotation()\nvar varWithCommentAndMeta = \"annotated\";\n");
        let plainNode = dart__ast__ast.AstNode.as(unit.childEntities[$first]);
        let span = src__barback_utils.getSpanForNode(sourceFile, plainNode);
        src__frontend__expect.expect(span.text, 'var plainVar = "plain";');
      }, VoidToNull()));
    }, VoidToNull()));
  };
  dart.trackLibraries("test/test__unit__barback_utils_test", {
    "unit/barback_utils_test.dart": unit__barback_utils_test
  }, '{"version":3,"sourceRoot":"","sources":["unit/barback_utils_test.dart"],"names":[],"mappings":";;;;;;;;;;;;;;;;;;;;;MAwBa,uCAAc;YAAG;;;;AAS5B,cAAK,CAAC,yBAAyB;AAC7B,eAAI,CAAC,0CAA0C;AAC7C,YAAI,UAAU,IAAI,gCAAO,CAAC,qBAAqB;AAC/C,oCAAM,CAAC,sCAAmB,CAAC,OAAO,GAAG,QAAG,MAAM,CAAC;;AAGjD,eAAI,CAAC,mDAAmD;AACtD,YAAI,UACA,IAAI,gCAAO,CAAC,qBAAqB;AACrC,oCAAM,CAAC,sCAAmB,CAAC,OAAO,GAC9B,QAAG,MAAM,CAAC;;;AAIlB,cAAK,CAAC,oBAAoB;AACxB,eAAI,CAAC,wDAAwD;AAC3D,YAAI,aAAa,IAAI,+BAAqB,CAAC,uGAAc;AACzD,YAAI,OAAO,6BAAoB,CAAC,uGAAc;AAC9C,YAAI,0CAAgB,IAAI,cAAc,OAAK;AAC3C,YAAI,OAAO,iCAAc,CAAC,UAAU,EAAE,aAAa;AACnD,oCAAM,CAAC,IAAI,KAAK,EAAE;;AAGpB,eAAI,CAAC,qDAAqD;AACxD,YAAI,aAAa,IAAI,+BAAqB,CAAC,uGAAc;AACzD,YAAI,OAAO,6BAAoB,CAAC,uGAAc;AAC9C,YAAI,0CAAgB,IAAI,cAAc,OAAK;AAC3C,YAAI,OAAO,iCAAc,CAAC,UAAU,EAAE,aAAa,2BACvB;AAC5B,oCAAM,CACF,IAAI,KAAK,EACT,sBACE,eACA,iBACA,mDACI,CAAC;;AAGb,eAAI,CAAC,6DAA6D;AAChE,YAAI,aAAa,IAAI,+BAAqB,CAAC,uGAAc;AACzD,YAAI,OAAO,6BAAoB,CAAC,uGAAc;AAC9C,YAAI,sCAAY,IAAI,cAAc,QAAM;AACxC,YAAI,OAAO,iCAAc,CAAC,UAAU,EAAE,SAAS;AAC/C,oCAAM,CAAC,IAAI,KAAK,EAAE;;;EAGxB","file":"test__unit__barback_utils_test.js"}');
  // Exports:
  return {
    unit__barback_utils_test: unit__barback_utils_test
  };
});

//# sourceMappingURL=test__unit__barback_utils_test.js.map
