define(['dart_sdk', 'packages/transformer_utils/lib__transformer_utils', 'packages/test/lib__test', 'packages/source_span/lib__source_span', 'packages/barback/lib__barback', 'packages/mockito/lib__shared_0'], function(dart_sdk, lib__transformer_utils, lib__test, lib__source_span, lib__barback, lib__shared_0) {
  'use strict';
  const core = dart_sdk.core;
  const _interceptors = dart_sdk._interceptors;
  const dart = dart_sdk.dart;
  const dartx = dart_sdk.dartx;
  const src__jet_brains_friendly_logger = lib__transformer_utils.src__jet_brains_friendly_logger;
  const test = lib__test.test;
  const src__frontend__expect = lib__test.src__frontend__expect;
  const src__file = lib__source_span.src__file;
  const src__span = lib__source_span.src__span;
  const src__asset__asset_id = lib__barback.src__asset__asset_id;
  const src__log = lib__barback.src__log;
  const src__transformer__transform_logger = lib__barback.src__transformer__transform_logger;
  const src__mock = lib__shared_0.src__mock;
  const _root = Object.create(null);
  const unit__jet_brains_friendly_logger_test = Object.create(_root);
  const $join = dartx.join;
  const $indexOf = dartx.indexOf;
  let VoidToNull = () => (VoidToNull = dart.constFn(dart.fnType(core.Null, [])))();
  let JSArrayOfString = () => (JSArrayOfString = dart.constFn(_interceptors.JSArray$(core.String)))();
  let AssetIdAndLogLevelAndString__Tovoid = () => (AssetIdAndLogLevelAndString__Tovoid = dart.constFn(dart.fnType(dart.void, [src__asset__asset_id.AssetId, src__log.LogLevel, core.String, src__span.SourceSpan])))();
  unit__jet_brains_friendly_logger_test.main = function() {
    test.group('JetBrainsFriendlyLogger', dart.fn(() => {
      let mockWrappedLogger = null;
      let logger = null;
      test.setUp(dart.fn(() => {
        mockWrappedLogger = new unit__jet_brains_friendly_logger_test.MockTransformLogger.new();
        logger = new src__jet_brains_friendly_logger.JetBrainsFriendlyLogger.new(mockWrappedLogger);
      }, VoidToNull()));
      test.group('clickableReference()', dart.fn(() => {
        test.test('returns a properly-formatted reference to a source span', dart.fn(() => {
          let lines = JSArrayOfString().of(['line 1', 'line 2 TARGET', 'line 3']);
          let sourceFile = new src__file.SourceFile.fromString(lines[$join]('\n'), {url: 'source_url'});
          let span = sourceFile.span(sourceFile.getText(0)[$indexOf]('TARGET'));
          let formatted = src__jet_brains_friendly_logger.JetBrainsFriendlyLogger.clickableReference(span);
          src__frontend__expect.expect(formatted, '[source_url 2:8]: ');
        }, VoidToNull()));
        test.test('returns an empty string when the specified span is null', dart.fn(() => {
          src__frontend__expect.expect(src__jet_brains_friendly_logger.JetBrainsFriendlyLogger.clickableReference(null), '');
        }, VoidToNull()));
      }, VoidToNull()));
      test.group('highlightedSpanText()', dart.fn(() => {
        test.test('returns the highlighted text of a source span', dart.fn(() => {
          let lines = JSArrayOfString().of(['line 1', 'line 2 TARGET', 'line 3']);
          let sourceFile = new src__file.SourceFile.fromString(lines[$join]('\n'), {url: 'source_url'});
          let targetIndex = sourceFile.getText(0)[$indexOf]('TARGET');
          let span = sourceFile.span(targetIndex, targetIndex + 'TARGET'.length);
          src__frontend__expect.expect(span.text, 'TARGET', {reason: 'should have set up the test as expected'});
          let expectedLines = JSArrayOfString().of(['line 2 TARGET', '       ^^^^^^']);
          src__frontend__expect.expect(src__jet_brains_friendly_logger.JetBrainsFriendlyLogger.highlightedSpanText(span), expectedLines[$join]('\n'));
        }, VoidToNull()));
      }, VoidToNull()));
      test.group('proxies logs methods,', dart.fn(() => {
        let span = null;
        let spanReference = null;
        let highlightedSpan = null;
        let asset = null;
        let message = null;
        test.setUp(dart.fn(() => {
          let sourceFile = new src__file.SourceFile.fromString('source file');
          span = sourceFile.span(0);
          spanReference = src__jet_brains_friendly_logger.JetBrainsFriendlyLogger.clickableReference(span);
          highlightedSpan = src__jet_brains_friendly_logger.JetBrainsFriendlyLogger.highlightedSpanText(span);
          asset = new src__asset__asset_id.AssetId.new('package', 'path');
          message = 'message';
        }, VoidToNull()));
        test.group('prepends the message with the formatted source span', dart.fn(() => {
          test.test('info()', dart.fn(() => {
            logger.info(message, {asset: asset, span: span});
            src__mock.verify(dart.void, mockWrappedLogger.info(dart.str`${spanReference}${message}\n${highlightedSpan}`, {asset: asset}));
          }, VoidToNull()));
          test.test('fine()', dart.fn(() => {
            logger.fine(message, {asset: asset, span: span});
            src__mock.verify(dart.void, mockWrappedLogger.fine(dart.str`${spanReference}${message}\n${highlightedSpan}`, {asset: asset}));
          }, VoidToNull()));
          test.test('warning()', dart.fn(() => {
            logger.warning(message, {asset: asset, span: span});
            src__mock.verify(dart.void, mockWrappedLogger.warning(dart.str`${spanReference}${message}\n${highlightedSpan}`, {asset: asset}));
          }, VoidToNull()));
          test.test('error()', dart.fn(() => {
            logger.error(message, {asset: asset, span: span});
            src__mock.verify(dart.void, mockWrappedLogger.error(dart.str`${spanReference}${message}\n${highlightedSpan}`, {asset: asset}));
          }, VoidToNull()));
        }, VoidToNull()));
        test.group('leaves the message as-is when a span is not specified', dart.fn(() => {
          test.test('info()', dart.fn(() => {
            logger.info(message, {asset: asset});
            src__mock.verify(dart.void, mockWrappedLogger.info(message, {asset: asset}));
          }, VoidToNull()));
          test.test('fine()', dart.fn(() => {
            logger.fine(message, {asset: asset});
            src__mock.verify(dart.void, mockWrappedLogger.fine(message, {asset: asset}));
          }, VoidToNull()));
          test.test('warning()', dart.fn(() => {
            logger.warning(message, {asset: asset});
            src__mock.verify(dart.void, mockWrappedLogger.warning(message, {asset: asset}));
          }, VoidToNull()));
          test.test('error()', dart.fn(() => {
            logger.error(message, {asset: asset});
            src__mock.verify(dart.void, mockWrappedLogger.error(message, {asset: asset}));
          }, VoidToNull()));
        }, VoidToNull()));
      }, VoidToNull()));
    }, VoidToNull()));
  };
  const _logFunction = Symbol('_logFunction');
  unit__jet_brains_friendly_logger_test.MockTransformLogger = class MockTransformLogger extends src__mock.Mock {
    noSuchMethod(i) {
      return super.noSuchMethod(i);
    }
    info(message, namedArgs) {
      return dart.void._check(this.noSuchMethod(new dart.InvocationImpl.new('info', [message], {isMethod: true, namedArguments: namedArgs})));
    }
    fine(message, namedArgs) {
      return dart.void._check(this.noSuchMethod(new dart.InvocationImpl.new('fine', [message], {isMethod: true, namedArguments: namedArgs})));
    }
    warning(message, namedArgs) {
      return dart.void._check(this.noSuchMethod(new dart.InvocationImpl.new('warning', [message], {isMethod: true, namedArguments: namedArgs})));
    }
    error(message, namedArgs) {
      return dart.void._check(this.noSuchMethod(new dart.InvocationImpl.new('error', [message], {isMethod: true, namedArguments: namedArgs})));
    }
    get [_logFunction]() {
      return AssetIdAndLogLevelAndString__Tovoid()._check(this.noSuchMethod(new dart.InvocationImpl.new(_logFunction, [], {isGetter: true})));
    }
  };
  (unit__jet_brains_friendly_logger_test.MockTransformLogger.new = function() {
    unit__jet_brains_friendly_logger_test.MockTransformLogger.__proto__.new.call(this);
  }).prototype = unit__jet_brains_friendly_logger_test.MockTransformLogger.prototype;
  dart.addTypeTests(unit__jet_brains_friendly_logger_test.MockTransformLogger);
  unit__jet_brains_friendly_logger_test.MockTransformLogger[dart.implements] = () => [src__transformer__transform_logger.TransformLogger];
  dart.setMethodSignature(unit__jet_brains_friendly_logger_test.MockTransformLogger, () => ({
    __proto__: dart.getMethods(unit__jet_brains_friendly_logger_test.MockTransformLogger.__proto__),
    info: dart.fnType(dart.void, [core.String], {asset: src__asset__asset_id.AssetId, span: src__span.SourceSpan}),
    fine: dart.fnType(dart.void, [core.String], {asset: src__asset__asset_id.AssetId, span: src__span.SourceSpan}),
    warning: dart.fnType(dart.void, [core.String], {asset: src__asset__asset_id.AssetId, span: src__span.SourceSpan}),
    error: dart.fnType(dart.void, [core.String], {asset: src__asset__asset_id.AssetId, span: src__span.SourceSpan})
  }));
  dart.setGetterSignature(unit__jet_brains_friendly_logger_test.MockTransformLogger, () => ({
    __proto__: dart.getGetters(unit__jet_brains_friendly_logger_test.MockTransformLogger.__proto__),
    [_logFunction]: dart.fnType(dart.void, [src__asset__asset_id.AssetId, src__log.LogLevel, core.String, src__span.SourceSpan])
  }));
  dart.defineExtensionMethods(unit__jet_brains_friendly_logger_test.MockTransformLogger, ['noSuchMethod']);
  dart.trackLibraries("test/test__unit__jet_brains_friendly_logger_test", {
    "unit/jet_brains_friendly_logger_test.dart": unit__jet_brains_friendly_logger_test
  }, '{"version":3,"sourceRoot":"","sources":["unit/jet_brains_friendly_logger_test.dart"],"names":[],"mappings":";;;;;;;;;;;;;;;;;;;;;;;AAwBE,cAAK,CAAC,2BAA2B;AAC/B,UAAoB;AACpB,UAAwB;AAExB,gBAAK,CAAC;AACJ,yBAAiB,GAAG,IAAI,6DAAmB;AAC3C,cAAM,GAAG,IAAI,2DAAuB,CAAC,iBAAiB;;AAGxD,gBAAK,CAAC,wBAAwB;AAC5B,iBAAI,CAAC,2DAA2D;AAC9D,cAAI,QAAQ,sBAAC,UAAU,iBAAiB;AACxC,cAAI,aACA,IAAI,+BAAqB,CAAC,KAAK,OAAK,CAAC,aAAY;AACrD,cAAI,OAAO,UAAU,KAAK,CAAC,UAAU,QAAQ,CAAC,YAAU,CAAC;AACzD,cAAI,YAAY,uDAAuB,mBAAmB,CAAC,IAAI;AAC/D,sCAAM,CAAC,SAAS,EAAE;;AAGpB,iBAAI,CAAC,2DAA2D;AAC9D,sCAAM,CAAC,uDAAuB,mBAAmB,CAAC,OAAO;;;AAI7D,gBAAK,CAAC,yBAAyB;AAC7B,iBAAI,CAAC,iDAAiD;AACpD,cAAI,QAAQ,sBAAC,UAAU,iBAAiB;AACxC,cAAI,aACA,IAAI,+BAAqB,CAAC,KAAK,OAAK,CAAC,aAAY;AACrD,cAAI,cAAc,UAAU,QAAQ,CAAC,YAAU,CAAC;AAChD,cAAI,OAAO,UAAU,KAAK,CAAC,WAAW,EAAE,AAAY,WAAD,GAAG,eAAe;AACrE,sCAAM,CAAC,IAAI,KAAK,EAAE,mBACN;AAEZ,cAAI,gBAAgB,sBAClB,iBACA;AAEF,sCAAM,CAAC,uDAAuB,oBAAoB,CAAC,IAAI,GACnD,aAAa,OAAK,CAAC;;;AAI3B,gBAAK,CAAC,yBAAyB;AAC7B,YAAW;AACX,YAAO;AACP,YAAO;AACP,YAAQ;AACR,YAAO;AAEP,kBAAK,CAAC;AACJ,cAAI,aAAa,IAAI,+BAAqB,CAAC;AAE3C,cAAI,GAAG,UAAU,KAAK,CAAC;AACvB,uBAAa,GAAG,uDAAuB,mBAAmB,CAAC,IAAI;AAC/D,yBAAe,GAAG,uDAAuB,oBAAoB,CAAC,IAAI;AAClE,eAAK,GAAG,IAAI,gCAAO,CAAC,WAAW;AAC/B,iBAAO,GAAG;;AAGZ,kBAAK,CAAC,uDAAuD;AAC3D,mBAAI,CAAC,UAAU;AACb,kBAAM,KAAK,CAAC,OAAO,UAAS,KAAK,QAAQ,IAAI;AAC7C,4BAAM,YAAC,iBAAiB,KACf,CAAC,WAAE,aAAa,GAAC,OAAO,KAAG,eAAe,YAAU,KAAK;;AAGpE,mBAAI,CAAC,UAAU;AACb,kBAAM,KAAK,CAAC,OAAO,UAAS,KAAK,QAAQ,IAAI;AAC7C,4BAAM,YAAC,iBAAiB,KACf,CAAC,WAAE,aAAa,GAAC,OAAO,KAAG,eAAe,YAAU,KAAK;;AAGpE,mBAAI,CAAC,aAAa;AAChB,kBAAM,QAAQ,CAAC,OAAO,UAAS,KAAK,QAAQ,IAAI;AAChD,4BAAM,YAAC,iBAAiB,QAAQ,CAC5B,WAAE,aAAa,GAAC,OAAO,KAAG,eAAe,YAClC,KAAK;;AAGlB,mBAAI,CAAC,WAAW;AACd,kBAAM,MAAM,CAAC,OAAO,UAAS,KAAK,QAAQ,IAAI;AAC9C,4BAAM,YAAC,iBAAiB,MACd,CAAC,WAAE,aAAa,GAAC,OAAO,KAAG,eAAe,YAAU,KAAK;;;AAIvE,kBAAK,CAAC,yDAAyD;AAC7D,mBAAI,CAAC,UAAU;AACb,kBAAM,KAAK,CAAC,OAAO,UAAS,KAAK;AACjC,4BAAM,YAAC,iBAAiB,KAAK,CAAC,OAAO,UAAS,KAAK;;AAGrD,mBAAI,CAAC,UAAU;AACb,kBAAM,KAAK,CAAC,OAAO,UAAS,KAAK;AACjC,4BAAM,YAAC,iBAAiB,KAAK,CAAC,OAAO,UAAS,KAAK;;AAGrD,mBAAI,CAAC,aAAa;AAChB,kBAAM,QAAQ,CAAC,OAAO,UAAS,KAAK;AACpC,4BAAM,YAAC,iBAAiB,QAAQ,CAAC,OAAO,UAAS,KAAK;;AAGxD,mBAAI,CAAC,WAAW;AACd,kBAAM,MAAM,CAAC,OAAO,UAAS,KAAK;AAClC,4BAAM,YAAC,iBAAiB,MAAM,CAAC,OAAO,UAAS,KAAK;;;;;EAK9D;;;iBAGe,CAAC;YAAK,mBAAkB,CAAC,CAAC;IAAC;;;;;;;;;;;;;;;;;;;EAC1C","file":"test__unit__jet_brains_friendly_logger_test.js"}');
  // Exports:
  return {
    unit__jet_brains_friendly_logger_test: unit__jet_brains_friendly_logger_test
  };
});

//# sourceMappingURL=test__unit__jet_brains_friendly_logger_test.js.map
