define(['dart_sdk', 'test/test__shared_0', 'packages/analyzer/lib__analyzer', 'packages/transformer_utils/lib__transformer_utils', 'packages/matcher/lib__shared_0', 'packages/test/lib__test'], function(dart_sdk, test__shared_0, lib__analyzer, lib__transformer_utils, lib__shared_0, lib__test) {
  'use strict';
  const core = dart_sdk.core;
  const dart = dart_sdk.dart;
  const dartx = dart_sdk.dartx;
  const test_utils = test__shared_0.test_utils;
  const dart__ast__ast = lib__analyzer.dart__ast__ast;
  const src__node_with_meta = lib__transformer_utils.src__node_with_meta;
  const src__core_matchers = lib__shared_0.src__core_matchers;
  const src__frontend__expect = lib__test.src__frontend__expect;
  const test = lib__test.test;
  const src__frontend__throws_matchers = lib__test.src__frontend__throws_matchers;
  const _root = Object.create(null);
  const unit__node_with_meta_test = Object.create(_root);
  let NodeWithMetaOfTopLevelVariableDeclaration$TestAnnotation = () => (NodeWithMetaOfTopLevelVariableDeclaration$TestAnnotation = dart.constFn(src__node_with_meta.NodeWithMeta$(dart__ast__ast.TopLevelVariableDeclaration, test_utils.TestAnnotation)))();
  let VoidToNull = () => (VoidToNull = dart.constFn(dart.fnType(core.Null, [])))();
  let VoidToTestAnnotation = () => (VoidToTestAnnotation = dart.constFn(dart.fnType(test_utils.TestAnnotation, [])))();
  unit__node_with_meta_test.main = function() {
    test.group('NodeWithMeta', dart.fn(() => {
      test.test('instantiates and provides access to an annotation and node', dart.fn(() => {
        let member = test_utils.parseAndGetSingleMember('@TestAnnotation("hello")\nvar a;');
        let nodeWithMeta = new (NodeWithMetaOfTopLevelVariableDeclaration$TestAnnotation()).new(dart__ast__ast.TopLevelVariableDeclaration._check(member));
        src__frontend__expect.expect(nodeWithMeta.node, src__core_matchers.same(member));
        src__frontend__expect.expect(nodeWithMeta.metaNode, src__core_matchers.isNotNull);
        src__frontend__expect.expect(nodeWithMeta.metaNode.name.name, 'TestAnnotation');
        src__frontend__expect.expect(nodeWithMeta.meta, src__core_matchers.isNotNull);
        src__frontend__expect.expect(nodeWithMeta.meta.positional, 'hello');
      }, VoidToNull()));
      test.test('partially instantiates an "incomplete" annotation', dart.fn(() => {
        let member = test_utils.parseAndGetSingleMember('@TestAnnotation(someIdentifier, named: "hello")\nvar a;');
        let nodeWithMeta = new (NodeWithMetaOfTopLevelVariableDeclaration$TestAnnotation()).new(dart__ast__ast.TopLevelVariableDeclaration._check(member));
        src__frontend__expect.expect(nodeWithMeta.node, src__core_matchers.same(member));
        src__frontend__expect.expect(nodeWithMeta.metaNode, src__core_matchers.isNotNull);
        src__frontend__expect.expect(nodeWithMeta.metaNode.name.name, 'TestAnnotation');
        src__frontend__expect.expect(nodeWithMeta.isIncomplete, src__core_matchers.isTrue);
        src__frontend__expect.expect(nodeWithMeta.unsupportedArguments, src__core_matchers.hasLength(1));
        src__frontend__expect.expect(dart.fn(() => nodeWithMeta.meta, VoidToTestAnnotation()), src__frontend__throws_matchers.throwsStateError);
        src__frontend__expect.expect(nodeWithMeta.potentiallyIncompleteMeta, src__core_matchers.isNotNull, {reason: 'should still have attempted to instantiate the incomplete annotation'});
        src__frontend__expect.expect(nodeWithMeta.potentiallyIncompleteMeta.named, src__core_matchers.equals('hello'), {reason: 'should still have passed the supported argument'});
        src__frontend__expect.expect(nodeWithMeta.potentiallyIncompleteMeta.positional, src__core_matchers.isNull, {reason: 'should have used null for unsupported argument'});
      }, VoidToNull()));
      test.test('gracefully handles a node without an annotation', dart.fn(() => {
        let member = test_utils.parseAndGetSingleMember('var a;');
        let nodeWithMeta = new (NodeWithMetaOfTopLevelVariableDeclaration$TestAnnotation()).new(dart__ast__ast.TopLevelVariableDeclaration._check(member));
        src__frontend__expect.expect(nodeWithMeta.node, src__core_matchers.same(member));
        src__frontend__expect.expect(nodeWithMeta.metaNode, src__core_matchers.isNull);
        src__frontend__expect.expect(nodeWithMeta.meta, src__core_matchers.isNull);
      }, VoidToNull()));
    }, VoidToNull()));
  };
  dart.trackLibraries("test/test__unit__node_with_meta_test", {
    "unit/node_with_meta_test.dart": unit__node_with_meta_test
  }, '{"version":3,"sourceRoot":"","sources":["unit/node_with_meta_test.dart"],"names":[],"mappings":";;;;;;;;;;;;;;;;;;AAyBE,cAAK,CAAC,gBAAgB;AACpB,eAAI,CAAC,8DAA8D;AACjE,YAAI,SAAS,kCAAuB,CAAC;AACrC,YAAI,eACA,IAAI,gEAAyD,mDAAC,MAAM;AAExE,oCAAM,CAAC,YAAY,KAAK,EAAE,uBAAI,CAAC,MAAM;AACrC,oCAAM,CAAC,YAAY,SAAS,EAAE,4BAAS;AACvC,oCAAM,CAAC,YAAY,SAAS,KAAK,KAAK,EAAE;AACxC,oCAAM,CAAC,YAAY,KAAK,EAAE,4BAAS;AACnC,oCAAM,CAAC,YAAY,KAAK,WAAW,EAAE;;AAGvC,eAAI,CAAC,qDAAqD;AACxD,YAAI,SAAS,kCAAuB,CAChC;AACJ,YAAI,eACA,IAAI,gEAAyD,mDAAC,MAAM;AAExE,oCAAM,CAAC,YAAY,KAAK,EAAE,uBAAI,CAAC,MAAM;AACrC,oCAAM,CAAC,YAAY,SAAS,EAAE,4BAAS;AACvC,oCAAM,CAAC,YAAY,SAAS,KAAK,KAAK,EAAE;AAExC,oCAAM,CAAC,YAAY,aAAa,EAAE,yBAAM;AACxC,oCAAM,CAAC,YAAY,qBAAqB,EAAE,4BAAS,CAAC;AACpD,oCAAM,CAAC,cAAM,YAAY,KAAK,2BAAE,+CAAgB;AAEhD,oCAAM,CAAC,YAAY,0BAA0B,EAAE,4BAAS,WAEhD;AACR,oCAAM,CAAC,YAAY,0BAA0B,MAAM,EAAE,yBAAM,CAAC,mBAChD;AACZ,oCAAM,CAAC,YAAY,0BAA0B,WAAW,EAAE,yBAAM,WACpD;;AAGd,eAAI,CAAC,mDAAmD;AACtD,YAAI,SAAS,kCAAuB,CAAC;AACrC,YAAI,eACA,IAAI,gEAAyD,mDAAC,MAAM;AAExE,oCAAM,CAAC,YAAY,KAAK,EAAE,uBAAI,CAAC,MAAM;AACrC,oCAAM,CAAC,YAAY,SAAS,EAAE,yBAAM;AACpC,oCAAM,CAAC,YAAY,KAAK,EAAE,yBAAM;;;EAGtC","file":"test__unit__node_with_meta_test.js"}');
  // Exports:
  return {
    unit__node_with_meta_test: unit__node_with_meta_test
  };
});

//# sourceMappingURL=test__unit__node_with_meta_test.js.map
