(function() {
var _currentDirectory = (function () {
  var _url;
  var lines = new Error().stack.split('\n');
  function lookupUrl() {
    if (lines.length > 2) {
      var match = lines[1].match(/^\s+at (.+):\d+:\d+$/);
      // Chrome.
      if (match) return match[1];
      // Chrome nested eval case.
      match = lines[1].match(/^\s+at eval [(](.+):\d+:\d+[)]$/);
      if (match) return match[1];
      // Edge.
      match = lines[1].match(/^\s+at.+\((.+):\d+:\d+\)$/);
      if (match) return match[1];
      // Firefox.
      match = lines[0].match(/[<][@](.+):\d+:\d+$/)
      if (match) return match[1];
    }
    // Safari.
    return lines[0].match(/(.+):\d+:\d+$/)[1];
  }
  _url = lookupUrl();
  var lastSlash = _url.lastIndexOf('/');
  if (lastSlash == -1) return _url;
  var currentDirectory = _url.substring(0, lastSlash + 1);
  return currentDirectory;
})();

let modulePaths = {
 "../test__unit__node_with_meta_test": "../test__unit__node_with_meta_test",
 "dart_sdk": "dart_sdk",
 "packages/analyzer/lib__analyzer": "../packages/analyzer/lib__analyzer",
 "packages/yaml/lib__yaml": "../packages/yaml/lib__yaml",
 "packages/source_span/lib__source_span": "../packages/source_span/lib__source_span",
 "packages/charcode/lib__charcode": "../packages/charcode/lib__charcode",
 "packages/charcode/lib__ascii": "../packages/charcode/lib__ascii",
 "packages/charcode/lib__html_entity": "../packages/charcode/lib__html_entity",
 "packages/path/lib__path": "../packages/path/lib__path",
 "packages/collection/lib__collection": "../packages/collection/lib__collection",
 "packages/collection/lib__shared_1": "../packages/collection/lib__shared_1",
 "packages/collection/lib__shared_0": "../packages/collection/lib__shared_0",
 "packages/collection/lib__shared_2": "../packages/collection/lib__shared_2",
 "packages/collection/lib__shared_3": "../packages/collection/lib__shared_3",
 "packages/collection/lib__shared_4": "../packages/collection/lib__shared_4",
 "packages/collection/lib__shared_5": "../packages/collection/lib__shared_5",
 "packages/string_scanner/lib__string_scanner": "../packages/string_scanner/lib__string_scanner",
 "packages/analyzer/lib__exception__exception": "../packages/analyzer/lib__exception__exception",
 "packages/analyzer/lib__dart__ast__token": "../packages/analyzer/lib__dart__ast__token",
 "packages/front_end/lib__src__scanner__token": "../packages/front_end/lib__src__scanner__token",
 "packages/front_end/lib__src__base__syntactic_entity": "../packages/front_end/lib__src__base__syntactic_entity",
 "packages/front_end/lib__src__fasta__scanner__token_constants": "../packages/front_end/lib__src__fasta__scanner__token_constants",
 "packages/front_end/lib__src__fasta__scanner__characters": "../packages/front_end/lib__src__fasta__scanner__characters",
 "packages/front_end/lib__src__scanner__string_utilities": "../packages/front_end/lib__src__scanner__string_utilities",
 "packages/front_end/lib__src__scanner__interner": "../packages/front_end/lib__src__scanner__interner",
 "packages/analyzer/lib__shared_0": "../packages/analyzer/lib__shared_0",
 "packages/front_end/lib__src__fasta__builder__qualified_name": "../packages/front_end/lib__src__fasta__builder__qualified_name",
 "packages/front_end/lib__src__fasta__kernel__metadata_collector": "../packages/front_end/lib__src__fasta__kernel__metadata_collector",
 "packages/kernel/lib__kernel": "../packages/kernel/lib__kernel",
 "packages/kernel/lib__ast": "../packages/kernel/lib__ast",
 "packages/kernel/lib__shared_0": "../packages/kernel/lib__shared_0",
 "packages/kernel/lib__util__graph": "../packages/kernel/lib__util__graph",
 "packages/kernel/lib__coq_annot": "../packages/kernel/lib__coq_annot",
 "packages/kernel/lib__binary__ast_to_binary": "../packages/kernel/lib__binary__ast_to_binary",
 "packages/kernel/lib__binary__tag": "../packages/kernel/lib__binary__tag",
 "packages/kernel/lib__binary__ast_from_binary": "../packages/kernel/lib__binary__ast_from_binary",
 "packages/front_end/lib__src__incremental__kernel_driver": "../packages/front_end/lib__src__incremental__kernel_driver",
 "packages/meta/lib__meta": "../packages/meta/lib__meta",
 "packages/front_end/lib__src__api_prototype__byte_store": "../packages/front_end/lib__src__api_prototype__byte_store",
 "packages/front_end/lib__src__byte_store__byte_store": "../packages/front_end/lib__src__byte_store__byte_store",
 "packages/front_end/lib__src__byte_store__cache": "../packages/front_end/lib__src__byte_store__cache",
 "packages/front_end/lib__src__byte_store__file_byte_store": "../packages/front_end/lib__src__byte_store__file_byte_store",
 "packages/front_end/lib__src__api_prototype__compilation_message": "../packages/front_end/lib__src__api_prototype__compilation_message",
 "packages/front_end/lib__src__fasta__severity": "../packages/front_end/lib__src__fasta__severity",
 "packages/front_end/lib__src__api_prototype__file_system": "../packages/front_end/lib__src__api_prototype__file_system",
 "packages/front_end/lib__src__base__api_signature": "../packages/front_end/lib__src__base__api_signature",
 "packages/convert/lib__convert": "../packages/convert/lib__convert",
 "packages/typed_data/lib__typed_data": "../packages/typed_data/lib__typed_data",
 "packages/typed_data/lib__typed_buffers": "../packages/typed_data/lib__typed_buffers",
 "packages/crypto/lib__crypto": "../packages/crypto/lib__crypto",
 "packages/front_end/lib__src__base__performance_logger": "../packages/front_end/lib__src__base__performance_logger",
 "packages/front_end/lib__src__base__processed_options": "../packages/front_end/lib__src__base__processed_options",
 "packages/package_config/lib__packages": "../packages/package_config/lib__packages",
 "packages/package_config/lib__shared_0": "../packages/package_config/lib__shared_0",
 "packages/front_end/lib__src__base__libraries_specification": "../packages/front_end/lib__src__base__libraries_specification",
 "packages/front_end/lib__src__fasta__util__relativize": "../packages/front_end/lib__src__fasta__util__relativize",
 "packages/front_end/lib__src__fasta__fasta_codes": "../packages/front_end/lib__src__fasta__fasta_codes",
 "packages/front_end/lib__src__fasta__uri_translator": "../packages/front_end/lib__src__fasta__uri_translator",
 "packages/front_end/lib__src__api_prototype__compiler_options": "../packages/front_end/lib__src__api_prototype__compiler_options",
 "packages/kernel/lib__target__flutter": "../packages/kernel/lib__target__flutter",
 "packages/kernel/lib__transformations__generic_types_reification": "../packages/kernel/lib__transformations__generic_types_reification",
 "packages/kernel/lib__transformations__reify__reify_transformer": "../packages/kernel/lib__transformations__reify__reify_transformer",
 "packages/kernel/lib__transformations__reify__analysis__program_analysis": "../packages/kernel/lib__transformations__reify__analysis__program_analysis",
 "packages/kernel/lib__transformations__reify__asts": "../packages/kernel/lib__transformations__reify__asts",
 "packages/kernel/lib__verifier": "../packages/kernel/lib__verifier",
 "packages/kernel/lib__transformations__reify__transformation__remove_generics": "../packages/kernel/lib__transformations__reify__transformation__remove_generics",
 "packages/kernel/lib__transformations__reify__transformation__transformer": "../packages/kernel/lib__transformations__reify__transformation__transformer",
 "packages/kernel/lib__transformations__reify__transformation__binding": "../packages/kernel/lib__transformations__reify__transformation__binding",
 "packages/kernel/lib__transformations__reify__transformation__builder": "../packages/kernel/lib__transformations__reify__transformation__builder",
 "packages/kernel/lib__transformations__async": "../packages/kernel/lib__transformations__async",
 "packages/kernel/lib__transformations__sanitize_for_vm": "../packages/kernel/lib__transformations__sanitize_for_vm",
 "packages/kernel/lib__transformations__treeshaker": "../packages/kernel/lib__transformations__treeshaker",
 "packages/kernel/lib__transformations__closure_conversion": "../packages/kernel/lib__transformations__closure_conversion",
 "packages/kernel/lib__transformations__closure__context": "../packages/kernel/lib__transformations__closure__context",
 "packages/kernel/lib__frontend__accessors": "../packages/kernel/lib__frontend__accessors",
 "packages/kernel/lib__clone": "../packages/kernel/lib__clone",
 "packages/kernel/lib__transformations__closure__clone_without_body": "../packages/kernel/lib__transformations__closure__clone_without_body",
 "packages/kernel/lib__transformations__closure__info": "../packages/kernel/lib__transformations__closure__info",
 "packages/kernel/lib__transformations__closure__invalidate_closures": "../packages/kernel/lib__transformations__closure__invalidate_closures",
 "packages/front_end/lib__src__api_prototype__standard_file_system": "../packages/front_end/lib__src__api_prototype__standard_file_system",
 "packages/front_end/lib__src__fasta__scanner__token": "../packages/front_end/lib__src__fasta__scanner__token",
 "packages/front_end/lib__src__fasta__scanner__string_canonicalizer": "../packages/front_end/lib__src__fasta__scanner__string_canonicalizer",
 "packages/package_config/lib__packages_file": "../packages/package_config/lib__packages_file",
 "packages/front_end/lib__src__fasta__ticker": "../packages/front_end/lib__src__fasta__ticker",
 "packages/front_end/lib__src__fasta__dill__built_type_builder": "../packages/front_end/lib__src__fasta__dill__built_type_builder",
 "packages/front_end/lib__src__fasta__builder__builder": "../packages/front_end/lib__src__fasta__builder__builder",
 "packages/front_end/lib__src__fasta__modifier": "../packages/front_end/lib__src__fasta__modifier",
 "packages/front_end/lib__src__fasta__parser": "../packages/front_end/lib__src__fasta__parser",
 "packages/front_end/lib__src__fasta__parser__assert": "../packages/front_end/lib__src__fasta__parser__assert",
 "packages/front_end/lib__src__fasta__util__link": "../packages/front_end/lib__src__fasta__util__link",
 "packages/front_end/lib__src__fasta__parser__member_kind": "../packages/front_end/lib__src__fasta__parser__member_kind",
 "packages/front_end/lib__src__fasta__parser__util": "../packages/front_end/lib__src__fasta__parser__util",
 "packages/front_end/lib__src__fasta__scanner": "../packages/front_end/lib__src__fasta__scanner",
 "packages/front_end/lib__src__fasta__scanner__keyword_state": "../packages/front_end/lib__src__fasta__scanner__keyword_state",
 "packages/front_end/lib__src__fasta__parser__async_modifier": "../packages/front_end/lib__src__fasta__parser__async_modifier",
 "packages/front_end/lib__src__fasta__parser__formal_parameter_kind": "../packages/front_end/lib__src__fasta__parser__formal_parameter_kind",
 "packages/front_end/lib__src__fasta__parser__loop_state": "../packages/front_end/lib__src__fasta__parser__loop_state",
 "packages/front_end/lib__src__fasta__parser__token_stream_rewriter": "../packages/front_end/lib__src__fasta__parser__token_stream_rewriter",
 "packages/front_end/lib__src__fasta__parser__type_continuation": "../packages/front_end/lib__src__fasta__parser__type_continuation",
 "packages/front_end/lib__src__fasta__parser__parser_error": "../packages/front_end/lib__src__fasta__parser__parser_error",
 "packages/front_end/lib__src__fasta__target": "../packages/front_end/lib__src__fasta__target",
 "packages/front_end/lib__src__fasta__combinator": "../packages/front_end/lib__src__fasta__combinator",
 "packages/front_end/lib__src__base__instrumentation": "../packages/front_end/lib__src__base__instrumentation",
 "packages/front_end/lib__src__fasta__source__unhandled_listener": "../packages/front_end/lib__src__fasta__source__unhandled_listener",
 "packages/front_end/lib__src__fasta__source__stack_listener": "../packages/front_end/lib__src__fasta__source__stack_listener",
 "packages/front_end/lib__src__fasta__quote": "../packages/front_end/lib__src__fasta__quote",
 "packages/front_end/lib__src__fasta__kernel__redirecting_factory_body": "../packages/front_end/lib__src__fasta__kernel__redirecting_factory_body",
 "packages/front_end/lib__src__fasta__kernel__forest": "../packages/front_end/lib__src__fasta__kernel__forest",
 "packages/front_end/lib__src__fasta__constant_context": "../packages/front_end/lib__src__fasta__constant_context",
 "packages/front_end/lib__src__fasta__names": "../packages/front_end/lib__src__fasta__names",
 "packages/front_end/lib__src__fasta__type_inference__type_constraint_gatherer": "../packages/front_end/lib__src__fasta__type_inference__type_constraint_gatherer",
 "packages/front_end/lib__src__fasta__type_inference__type_schema": "../packages/front_end/lib__src__fasta__type_inference__type_schema",
 "packages/front_end/lib__src__fasta__type_inference__type_schema_elimination": "../packages/front_end/lib__src__fasta__type_inference__type_schema_elimination",
 "packages/front_end/lib__src__fasta__kernel__constness": "../packages/front_end/lib__src__fasta__kernel__constness",
 "packages/front_end/lib__src__fasta__kernel__verifier": "../packages/front_end/lib__src__fasta__kernel__verifier",
 "packages/front_end/lib__src__fasta__source__diet_parser": "../packages/front_end/lib__src__fasta__source__diet_parser",
 "packages/front_end/lib__src__fasta__configuration": "../packages/front_end/lib__src__fasta__configuration",
 "packages/front_end/lib__src__base__resolve_relative_uri": "../packages/front_end/lib__src__base__resolve_relative_uri",
 "packages/front_end/lib__src__fasta__operator": "../packages/front_end/lib__src__fasta__operator",
 "packages/front_end/lib__src__fasta__source__scope_listener": "../packages/front_end/lib__src__fasta__source__scope_listener",
 "packages/front_end/lib__src__fasta__kernel__kernel_api": "../packages/front_end/lib__src__fasta__kernel__kernel_api",
 "packages/front_end/lib__src__fasta__kernel__utils": "../packages/front_end/lib__src__fasta__kernel__utils",
 "packages/kernel/lib__binary__limited_ast_to_binary": "../packages/kernel/lib__binary__limited_ast_to_binary",
 "packages/front_end/lib__src__incremental__file_state": "../packages/front_end/lib__src__incremental__file_state",
 "packages/front_end/lib__src__dependency_walker": "../packages/front_end/lib__src__dependency_walker",
 "packages/front_end/lib__src__incremental__format": "../packages/front_end/lib__src__incremental__format",
 "packages/front_end/lib__src__base__flat_buffers": "../packages/front_end/lib__src__base__flat_buffers",
 "packages/front_end/lib__src__incremental__unlinked_unit": "../packages/front_end/lib__src__incremental__unlinked_unit",
 "packages/front_end/lib__src__fasta__source__directive_listener": "../packages/front_end/lib__src__fasta__source__directive_listener",
 "packages/front_end/lib__src__scanner__reader": "../packages/front_end/lib__src__scanner__reader",
 "packages/front_end/lib__src__base__analysis_target": "../packages/front_end/lib__src__base__analysis_target",
 "packages/front_end/lib__src__base__timestamped_data": "../packages/front_end/lib__src__base__timestamped_data",
 "packages/front_end/lib__src__base__uri_kind": "../packages/front_end/lib__src__base__uri_kind",
 "packages/front_end/lib__src__scanner__errors": "../packages/front_end/lib__src__scanner__errors",
 "packages/front_end/lib__src__base__errors": "../packages/front_end/lib__src__base__errors",
 "packages/html/lib__dom": "../packages/html/lib__dom",
 "packages/csslib/lib__parser": "../packages/csslib/lib__parser",
 "packages/csslib/lib__shared_0": "../packages/csslib/lib__shared_0",
 "packages/logging/lib__logging": "../packages/logging/lib__logging",
 "packages/html/lib__shared_0": "../packages/html/lib__shared_0",
 "packages/utf/lib__utf": "../packages/utf/lib__utf",
 "packages/plugin/lib__manager": "../packages/plugin/lib__manager",
 "packages/args/lib__args": "../packages/args/lib__args",
 "packages/args/lib__shared_0": "../packages/args/lib__shared_0",
 "packages/glob/lib__glob": "../packages/glob/lib__glob",
 "packages/async/lib__async": "../packages/async/lib__async",
 "packages/analyzer/lib__dart__ast__syntactic_entity": "../packages/analyzer/lib__dart__ast__syntactic_entity",
 "packages/analyzer/lib__shared_1": "../packages/analyzer/lib__shared_1",
 "packages/front_end/lib__src__base__jenkins_smi_hash": "../packages/front_end/lib__src__base__jenkins_smi_hash",
 "packages/watcher/lib__watcher": "../packages/watcher/lib__watcher",
 "packages/front_end/lib__src__scanner__scanner": "../packages/front_end/lib__src__scanner__scanner",
 "packages/analyzer/lib__source__source_range": "../packages/analyzer/lib__source__source_range",
 "packages/test/lib__test": "../packages/test/lib__test",
 "packages/pub_semver/lib__pub_semver": "../packages/pub_semver/lib__pub_semver",
 "packages/test/lib__shared_0": "../packages/test/lib__shared_0",
 "packages/package_resolver/lib__package_resolver": "../packages/package_resolver/lib__package_resolver",
 "packages/http/lib__http": "../packages/http/lib__http",
 "packages/http/lib__shared_0": "../packages/http/lib__shared_0",
 "packages/http_parser/lib__http_parser": "../packages/http_parser/lib__http_parser",
 "packages/source_map_stack_trace/lib__source_map_stack_trace": "../packages/source_map_stack_trace/lib__source_map_stack_trace",
 "packages/source_maps/lib__source_maps": "../packages/source_maps/lib__source_maps",
 "packages/source_maps/lib__builder": "../packages/source_maps/lib__builder",
 "packages/source_maps/lib__shared_0": "../packages/source_maps/lib__shared_0",
 "packages/source_maps/lib__printer": "../packages/source_maps/lib__printer",
 "packages/source_maps/lib__refactor": "../packages/source_maps/lib__refactor",
 "packages/stack_trace/lib__stack_trace": "../packages/stack_trace/lib__stack_trace",
 "packages/boolean_selector/lib__boolean_selector": "../packages/boolean_selector/lib__boolean_selector",
 "packages/matcher/lib__matcher": "../packages/matcher/lib__matcher",
 "packages/matcher/lib__shared_0": "../packages/matcher/lib__shared_0",
 "packages/stream_channel/lib__stream_channel": "../packages/stream_channel/lib__stream_channel",
 "packages/pool/lib__pool": "../packages/pool/lib__pool",
 "packages/term_glyph/lib__term_glyph": "../packages/term_glyph/lib__term_glyph",
 "packages/transformer_utils/lib__transformer_utils": "../packages/transformer_utils/lib__transformer_utils",
 "packages/barback/lib__barback": "../packages/barback/lib__barback",
 "test/test__shared_0": "../test__shared_0"
};

if(!window.$dartLoader) {
   window.$dartLoader = {
     moduleIdToUrl: new Map(),
     urlToModuleId: new Map(),
     rootDirectories: new Array(),
   };
}

let customModulePaths = {};
window.$dartLoader.rootDirectories.push(_currentDirectory);
for (let moduleName of Object.getOwnPropertyNames(modulePaths)) {
  let modulePath = modulePaths[moduleName];
  if (modulePath != moduleName) {
    customModulePaths[moduleName] = modulePath;
  }
  var src = _currentDirectory + modulePath + '.js';
  if (window.$dartLoader.moduleIdToUrl.has(moduleName)) {
    continue;
  }
  $dartLoader.moduleIdToUrl.set(moduleName, src);
  $dartLoader.urlToModuleId.set(src, moduleName);
}
// Whenever we fail to load a JS module, try to request the corresponding
// `.errors` file, and log it to the console.
(function() {
  var oldOnError = requirejs.onError;
  requirejs.onError = function(e) {
    if (e.originalError && e.originalError.srcElement) {
      var xhr = new XMLHttpRequest();
      xhr.onreadystatechange = function() {
        if (this.readyState == 4 && this.status == 200) {
          console.error(this.responseText);
        }
      };
      xhr.open("GET", e.originalError.srcElement.src + ".errors", true);
      xhr.send();
    }
    // Also handle errors the normal way.
    if (oldOnError) oldOnError(e);
  };
}());

require.config({
    waitSeconds: 0,
    paths: customModulePaths
});

require(["../test__unit__node_with_meta_test", "dart_sdk"], function(app, dart_sdk) {
  dart_sdk._isolate_helper.startRootIsolate(() => {}, []);
  dart_sdk._debugger.registerDevtoolsFormatter();

  if (window.$dartStackTraceUtility && !window.$dartStackTraceUtility.ready) {
    window.$dartStackTraceUtility.ready = true;
    let dart = dart_sdk.dart;
    window.$dartStackTraceUtility.setSourceMapProvider(
      function(url) {
        var module = window.$dartLoader.urlToModuleId.get(url);
        if (!module) return null;
        return dart.getSourceMap(module);
      });
  }
  window.postMessage({ type: "DDC_STATE_CHANGE", state: "start" }, "*");
  app.unit__node_with_meta_test.main();
});
})();
